; FileMan.inc
;--------------------------------------------------------------------------------------------------

; System includes
;         include   L:\MASM32\include\Win32API01.inc
;         include   L:\MASM32\include\Win32API02.inc
         include   L:\MASM32\include\Windows.inc
         include   L:\MASM32\include\Supplment.inc
         include   L:\MASM32\include\kernel32.inc 
         include   L:\MASM32\include\user32.inc  
         include   L:\MASM32\include\comctl32.inc
         include   L:\MASM32\include\COMDLG32.inc
         include   L:\MASM32\include\GDI32.inc
         include   L:\MASM32\include\ole32.inc                  
         include   L:\MASM32\include\shell32.inc
         include   L:\MASM32\include\ADVAPI32.inc
;         include   \MASM32V1\include\version.inc
;         include   \MASM32V1\include\DSPMACRO.asm
                           
         includelib   L:\Masm32\LIB\USER32.LIB
         includelib   L:\Masm32\LIB\KERNEL32.LIB
         includelib   L:\Masm32\LIB\GDI32.LIB
         includelib   L:\Masm32\LIB\COMDLG32.LIB
         includelib   L:\Masm32\LIB\COMCTL32.LIB
         includelib   L:\Masm32\LIB\TAPI32.LIB
         includelib   L:\Masm32\LIB\WINMM.LIB
         includelib   L:\Masm32\LIB\WINSPOOL.LIB
         includelib   L:\Masm32\LIB\ole32.lib
         includelib   L:\Masm32\LIB\shell32.lib
         includelib   L:\MASM32\LIB\ADVAPI32.LIB


; User defined messages
WM_CALLTOOLPROC equ WM_USER       ; Call toolbar proc subclass

MOVmd    MACRO Var1, Var2
               push     Var2
                pop     Var1
         ENDM

MOVmw    MACRO Var1, Var2
               lea     esi, Var2
               lea     edx, Var1
            REPEAT     2
                  mov     al, [esi]
                  mov     [edx], al
                  inc     esi
                  inc     edx
            ENDM
         ENDM

;--------------------------------------------------------------------------------------------------
; Constants
ID_TIMER         equ    900
ID_TREEVIEW      equ  1002h
ID_LISTVIEW      equ  1003h
ID_LISTVIEWL     equ  1004h
ID_LISTVIEWR     equ  1005h
ID_STATUSVIEW    equ  1006h
;ID_HEADER1       equ  1007h
;--------------------------------------------------------------------------------------------------
; Resource identifiers

IDM_HELPTOPICS   equ    1001
IDR_MENU1        equ    1002 
IDM_NEW          equ    1003
IDM_OPEN         equ    1004
IDM_QUIT         equ    1005
IDM_ABOUT        equ    1006
;IDM_FONT         equ    1007
IDI_ICON1        equ    1099

IDI_BACK         equ    4444
IDC_DRAG         equ    4445
IDC_DROP         equ    4446
IDI_EXIT         equ    4447
IDC_SPLIT        equ    4450

IDD_CONFIRM      equ    5000
IDD_COPY         equ    5001
IDD_DUPE         equ    5002
IDD_SPLITBAR     equ    5003
IDD_SPLITDATA    equ    5004
IDD_ATTR         equ    5005
IDD_VOL          equ    5006
IDD_FONT         equ    5007
IDD_ABOUT        equ    5010
IDD_ASSOCIATION  equ    5011
IDD_TABCTL       equ    5012
IDD_VIEW         equ    5013
IDD_SETTINGS     equ    5014
IDD_ZIP          equ    5015
IDD_EDIT         equ    5016

IDC_EDIT1        equ    6000
IDC_EDIT2        equ    6001
IDC_TO           equ    6002

IDR_ACCEL        equ    7001
IDM_TAB          equ    7002
IDM_RETURN       equ    7003
IDM_DELETE       equ    7004


COL_NAME         equ    0
COL_EXT          equ    1
COL_SIZE         equ    2
COL_DATE         equ    3
COL_ATTR         equ    4
COL_TYPE         equ    5

;--------------------------------------------------------------------------------------------------

LV_OBJDATA struct DWORD
      pshfParent   DWORD          ? ;LPSHELLFOLDER  ?
      pidlRel      DWORD          ? ;LPITEMIDLIST   ?
      pidlFull     DWORD          ? ;LPITEMIDLIST   ?
      dwAttr       DWORD          ?
      iItem        DWORD          ?
      sBack        DWORD          ?
LV_OBJDATA ends
LPLV_OBJDATA typedef PTR LV_OBJDATA
LPPLV_OBJDATA typedef ptr LPLV_OBJDATA


TV_OBJDATA struct DWORD
      pidlRel      LPITEMIDLIST   ?
      pidlFull     LPITEMIDLIST   ?
      pshfParent   LPSHELLFOLDER  ?
TV_OBJDATA ends
LPTV_OBJDATA typedef PTR TV_OBJDATA
LPPTV_OBJDATA typedef ptr LPTV_OBJDATA

HTREEITEM        TYPEDEF     DWORD    
ULARGE_INTEGER   TYPEDEF     QWORD
;--------------------------------------------------------------------------------------------------
; Globals

externdef        szLeft:BYTE
externdef        szTop:BYTE
externdef        szRight:BYTE
externdef        szBottom:BYTE
externdef        ViewFlags:DWORD
externdef        TreeVWidth:DWORD
externdef        SeparatorLeft:DWORD
externdef        SeparatorRight:DWORD
externdef        SavButtL:DWORD
externdef        SavButtR:DWORD
externdef        RestoreL:BYTE
externdef        RestoreR:BYTE
externdef        EditPgr:BYTE
externdef        ZipPack:BYTE
externdef        ZipUnPack:BYTE
externdef        PgmZip:BYTE
externdef        szSaveExit:BYTE
externdef        Column:DWORD
externdef        ColName:DWORD
externdef        ColExt:DWORD
externdef        ColSize:DWORD
externdef        ColDate:DWORD
externdef        ColAttr:DWORD
externdef        ColType:DWORD
externdef        LevCntL:DWORD
externdef        LevCntR:DWORD
externdef        BackHighLiteL:BYTE
externdef        BackHighLiteR:BYTE
externdef        RetLevCntL:DWORD
externdef        RetLevCntR:DWORD
externdef        RetRestoreL:BYTE
externdef        RetRestoreR:BYTE
externdef        RetBackHighLiteL:BYTE
externdef        RetBackHighLiteR:BYTE
externdef        RetSavPath:BYTE
externdef        RetszPathL:BYTE
externdef        RetszPathR:BYTE
externdef        RetszTitleL:BYTE
externdef        RetszTitleR:BYTE
externdef        RetSavButtL:DWORD
externdef        RetSavButtR:DWORD

externdef        sw1:DWORD
externdef        sw2:DWORD
externdef        Cmd:DWORD
externdef        Var:DWORD
externdef        Funct:DWORD
externdef        KillThread:DWORD
externdef        NoDelEnt:DWORD
externdef        DoColor:DWORD
externdef        osvID:DWORD
externdef        SavItem:DWORD
externdef        SavImageN:DWORD
externdef        SavIcon:DWORD
externdef        SortAD:DWORD
externdef        SortADL:DWORD
externdef        SortADR:DWORD
externdef        SortCol:DWORD
externdef        SortColL:DWORD
externdef        SortColR:DWORD
externdef        Change:DWORD
externdef        ShowGrid:DWORD
externdef        ShowHidden:DWORD
externdef        ShowProcessed:DWORD
externdef        ChkZip:DWORD
externdef        SaveExit:DWORD
externdef        CopyToRecycle:DWORD
externdef        TabSelect:DWORD
externdef        hlvobj:DWORD
externdef        hWndP:DWORD
externdef        hInst:DWORD
externdef        hFontL:DWORD
externdef        TextC:DWORD
externdef        TextBC:DWORD
externdef        BackGC:DWORD
externdef        FontS:DWORD
externdef        FontW:DWORD
externdef        PointSize:DWORD
externdef        szClear:BYTE
externdef        FontName:BYTE
externdef        FontNameS:BYTE
externdef        FontName2:BYTE
externdef        szArc:BYTE
externdef        szFill:BYTE
externdef        szDrv:BYTE
externdef        szVol:BYTE
externdef        SavPath:BYTE
externdef        SavDlgPath:BYTE
externdef        szString:BYTE
externdef        szPathL:BYTE
externdef        szPathR:BYTE
externdef        szTitleL:BYTE
externdef        szTitleR:BYTE
externdef        szStatus:BYTE
externdef        szStatusL:BYTE
externdef        szStatusR:BYTE
externdef        pShellMalloc:LPMALLOC
externdef        SavList:DWORD
externdef        PasteCmd:DWORD     
externdef        HoldCmd:DWORD     
externdef        HoldPos:DWORD     
externdef        szNoCutCopy:BYTE
externdef        szToolTip:BYTE
externdef        DriveArray:DWORD

externdef        hWndList:DWORD
externdef        hWndListL:DWORD
externdef        hWndListR:DWORD
externdef        hWndStatusBar:DWORD
externdef        hWndTree:DWORD
externdef        hToolBar:DWORD
externdef        hToolBarC:DWORD
externdef        hToolBarM:DWORD
externdef        hWndTool:DWORD
externdef        hComboL:DWORD
externdef        hComboR:DWORD
externdef        hStatL:DWORD
externdef        hStatR:DWORD
externdef        hToolBarL:DWORD
externdef        hToolBarR:DWORD
externdef        hChange:DWORD
externdef        hitemMyComputer:DWORD
externdef        pshf:DWORD
externdef        pidlBase:DWORD
externdef        StaticCnt:DWORD
externdef        ListTotS:DWORD 
externdef        ListTotSL:DWORD
externdef        ListTotSR:DWORD
externdef        ListTotN:DWORD 
externdef        ListTotNL:DWORD
externdef        ListTotNR:DWORD
externdef        ListSelS:DWORD 
externdef        ListSelSL:DWORD
externdef        ListSelSR:DWORD
externdef        ListSelN:DWORD 
externdef        ListSelNL:DWORD
externdef        ListSelNR:DWORD
externdef        hListImageList:DWORD
externdef        hDupeImageList:DWORD
externdef        FromTree:DWORD
externdef        AutoTree:DWORD
externdef        ThreadID:DWORD

externdef        LevCntR:DWORD  ;temp remove
externdef        NoUpdate:DWORD  ;temp remove
externdef        hStatic:DWORD  ;temp remove

;--------------------------------------------------------------------------------------------------
; Prototypes
WinMain          PROTO

;wsprintfA        PROTO C :VARARG
;wsprintf         equ <wsprintfA>

RegQuery         PROTO :DWORD, :DWORD
RegSet           PROTO :DWORD, :DWORD
RegSave          PROTO
RegCloseKey      PROTO :DWORD
Initialize       PROTO
PathToPidl       PROTO

GetHeader        PROTO
ChangeProc       PROTO

CreateThd        PROTO

LRProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD
SizeStatusBars   PROTO :DWORD
UpdateSelBars    PROTO
ListViewRestore  PROTO :DWORD
ListViewRefresh  PROTO :DWORD

InitListView     PROTO :DWORD, :DWORD, :DWORD, :DWORD
UpdateListView   PROTO :DWORD, :DWORD, :LPSHELLFOLDER
ListViewNotify   PROTO :DWORD, :DWORD, :DWORD
ListViewSort     PROTO :DWORD, :DWORD, :DWORD
CopyData         PROTO :DWORD, :DWORD, :DWORD
ExpColTree       PROTO :DWORD, :DWORD
TreeBranch       PROTO :DWORD

; General Functions       
InitTreeView     PROTO :DWORD, :DWORD                    
TreeViewNotify   PROTO :DWORD, :DWORD
UpdateTreeView   PROTO :DWORD, :LPSHELLFOLDER, :LPITEMIDLIST, :DWORD
ToolbarProc      PROTO :DWORD, :DWORD, :DWORD, :DWORD
AsciiBase        PROTO :DWORD, :DWORD, :DWORD
BaseAscii        PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
Static           PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
Button           PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
fmtime           PROTO :SYSTEMTIME
AbVerDlg         PROTO :DWORD, :DWORD, :DWORD, :DWORD
VolumeDlg        PROTO :DWORD, :DWORD, :DWORD, :DWORD
AttributesDlg    PROTO :DWORD, :DWORD, :DWORD, :DWORD
SplitBarDlg      PROTO :DWORD, :DWORD, :DWORD, :DWORD
SplitDataDlg     PROTO :DWORD, :DWORD, :DWORD, :DWORD
AssociationDlg   PROTO :DWORD, :DWORD, :DWORD, :DWORD
ConfirmDlg       PROTO :DWORD, :DWORD, :DWORD, :DWORD
CopyDlg          PROTO :DWORD, :DWORD, :DWORD, :DWORD
DupeDlg          PROTO :DWORD, :DWORD, :DWORD, :DWORD
ColorFontDlg     PROTO :DWORD, :DWORD, :DWORD, :DWORD
TabCtlDlg        PROTO :DWORD, :DWORD, :DWORD, :DWORD
ViewDlg          PROTO :DWORD, :DWORD, :DWORD, :DWORD
SettingsDlg      PROTO :DWORD, :DWORD, :DWORD, :DWORD
EditZipDlg       PROTO :DWORD, :DWORD, :DWORD, :DWORD

TestDlg          PROTO :DWORD, :DWORD, :DWORD, :DWORD

CenterWnd        PROTO :DWORD, :DWORD
SetButt          PROTO :DWORD
GetDrvRoot       PROTO :LPTV_OBJDATA
StatusBar        PROTO :DWORD, :DWORD, :DWORD, :DWORD

; Shell Namespace helper functions
GetIcon          PROTO :LPITEMIDLIST, :DWORD
ContextMenu      PROTO :DWORD, :LPSHELLFOLDER, :LPITEMIDLIST, :DWORD

; Item Id List functions
IDList_GetSize   PROTO :LPITEMIDLIST
IDList_Combine   PROTO :LPITEMIDLIST, :LPITEMIDLIST
IDList_CopyItem  PROTO :LPITEMIDLIST

;--------------------------------------------------------------------------------------------------

;LR_DEFAULTCOLOR         equ 0000h
;LR_MONOCHROME           equ 0001h
;LR_COLOR                equ 0002h
;LR_COPYRETURNORG        equ 0004h
;LR_COPYDELETEORG        equ 0008h
;LR_LOADFROMFILE         equ 0010h
;LR_LOADTRANSPARENT      equ 0020h
;LR_DEFAULTSIZE          equ 0040h
;LR_LOADMAP3DCOLORS      equ 01000h
;LR_CREATEDIBSECTION     equ 02000h
;LR_COPYFROMRESOURCE     equ 04000h
;LR_SHARED               equ 08000h

