PROJECT   = FileMan
OBJ_CORE  = FileMan.obj TreeView.obj ListView.obj Convert.obj Registry.obj
RESOURCES = IconF.ico

#ALL: $(PROJECT).exe $(PROJECT).hlp
ALL: $(PROJECT).exe


# Definition of assembler and linker options ****************************
!IFDEF debug
AssemblerOptions = /c /coff /Zi
LinkerOptions = /DEBUGTYPE:COFF /DEBUG:MAPPED,FULL
!ELSE
AssemblerOptions = /c /coff
LinkerOptions = /MAP
!ENDIF

# Inference rule for updating object files ******************************
.asm.obj:
	\MASM32\BIN\ML $(AssemblerOptions) $<

#$(OBJ_MORE)

# Build rule for executable *********************************************

$(PROJECT).exe:	$(OBJ_CORE) RSRC.RES
	\MASM32\BIN\LINK $(LinkerOptions) @<<LinkFile


/MACHINE:i386
/SUBSYSTEM:WINDOWS,4.0
/OUT:$(PROJECT).exe
$(OBJ_CORE)

RSRC.RES

<<NOKEEP

# Build rule for resource file ******************************************
# RSRC.RES:	RSRC.RES $(RESOURCES)
                          \MASM32\BIN\RC RSRC.RC

# Build rule for help file **********************************************
#$(PROJECT).hlp:	FileMan.hpj FileMan.rtf $(PROJECT).cnt

# Delete intermediate files *********************************************
Clean:
	Erase *.obj
	Erase *.res
