         title    ListView

         .586
         .model   flat, STDCALL

         option   casemap: none   ; case sensitive
         include  FileMan.inc

;------------------------------------------------------------------------------------------------------------
.const                                           ; constant data segment
szListViewName    db        'SysListView32',0
FontNameA         db        'Arial',0
FontNameT         db        'Times New Roman',0
szRootPath        db        'C:\',0
szAllFiles        db        '*.*',0
szBackS           db        '\',0
szSpace           db        ' ',0
szPif             db        '.pif',0
szZip             db        '.zip',0
szOpen            db        'Open',0
szNull            db        0
szColName         db        'Name',0
szColExt          db        'Ext ',0
szColSize         db        'Size     ',0
szColDate         db        'Date',0
szColAttr         db        'Attr',0
szColType         db        'Type',0
A                 db        ' A',0
D                 db        ' D',0
szDir             db        ' <DIR>',0
szBack            db        '[..]',0
szFill            db        '----',0
szDate            db        '08/19/1941 02:04:44',0 
szOf              db        ' of ',0
szIn              db        ' in ',0
szFiles           db        ' files selected',0
szNoCutCopy       db        'There was no Cut or Copy function',0Ah
                  db        ' from the source directory.',0 
Zeros             db        10  dup('0'),0
Clear             db        5   dup(' '),0
szRecyc           db        'RECYCLED',0
szEditError       db        'You first need to select an edit program from the option menu.',0

;---------------------------------------------------------------------------
.data

szArc             db        4   dup(?),0
szBuff            db        256 dup(?),0
szPath            db        256 dup(?),0
szString          db        256 dup(?),0
szWork            db        20  dup(0),0
szStatus          db        100 dup(0),0
LevCntL           dd        0
LevCntR           dd        0
RestoreL          db        20  dup(0),0
RestoreR          db        20  dup(0),0
BackHighLiteL     db        20  dup(0),0
BackHighLiteR     db        20  dup(0),0

RetLevCntL        dd        0
RetLevCntR        dd        0
RetRestoreL       db        20  dup(0),0
RetRestoreR       db        20  dup(0),0
RetBackHighLiteL  db        20  dup(0),0
RetBackHighLiteR  db        20  dup(0),0
RetSavPath        db        256 dup(' '),0
RetszPathL        db        100 dup(' '),0
RetszPathR        db        100 dup(' '),0
RetszTitleL       db        100 dup(' '),0
RetszTitleR       db        100 dup(' '),0

Column      LABEL DWORD
ColName           dd        125
ColExt            dd        42
ColSize           dd        60
ColDate           dd        135
ColAttr           dd        37
ColType           dd        0

hWndList          dd        0
hWndListL         dd        0                   ; Window handle for the List View Left
hWndListR         dd        0                   ; Window handle for the List View Right
hCol              dd        0
hColL             dd        0
hColR             dd        0
hColImageList     dd        0
hDupeImageList      dd        0
hListImageList    dd        0
hSingleImage      dd        0
hImageList        dd        0
hIcon             dd        0 
HoldT             dd        0
hWnd1             dd        0
hFile             dd        0
hFind             dd        0
AddIcon           dd        0
SortAD            dd        0
SortADL           dd        0
SortADR           dd        0
SortCol           dd        0
SortColL          dd        0
SortColR          dd        0
PasteCmd          dd        0
HoldCmd           dd        0
HoldPos           dd        0
ItemNum           dd        0
Cnt               dd        0
Val               dd        0
Num               dd        0
UD                dd        2   dup(0)

ListTotS          dd        0 
ListTotSL         dd        0
ListTotSR         dd        0
ListTotN          dd        0 
ListTotNL         dd        0
ListTotNR         dd        0

ListSelS          dd        0 
ListSelSL         dd        0
ListSelSR         dd        0
ListSelN          dd        0 
ListSelNL         dd        0
ListSelNR         dd        0

hpshfParent       dd        0
hptvobj           dd        0
hlvobj            dd        0
pshf              dd        0
pidlBase          dd        0

time        SYSTEMTIME       <>
ft          FILETIME         <>
shfi        SHFILEINFO       <>
rect        RECT             <>
FindData    WIN32_FIND_DATA  <?>
lf          LOGFONT          <?>
lvcol       LV_COLUMN        <?>

bri        BROWSEINFO        <>
hd         HD_ITEM           <>
;--------------------------------------------------------------------------
.code

;=========================================================================|
; InitListView PROCEDURE                                                  |
;=========================================================================|
InitListView     proc  uses ebx  hInstance:DWORD, hWndParent:DWORD, fut:DWORD, sw:DWORD
LOCAL    sfi:SHFILEINFO

        push     hWndParent
         pop     hWnd1
        push     SavList

;----- [Build both list views] -----
DoRight:

      .if sw == 0
            mov     SavList, 4
            mov     eax, ID_LISTVIEWL   
      .else
            mov     SavList, 8
            mov     eax, ID_LISTVIEWR   
      .endif

;----- [Create the list view windows] -----  LVS_LIST
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr szListViewName, 0,
                 WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_EDITLABELS or LVS_SHAREIMAGELISTS or\
                 LVS_SHOWSELALWAYS, 0, 0, 0, 0,
                 hWndParent, eax, hInstance, NULL
        test     eax,eax     
          jz     ret_error

         mov     ebx, SavList
         mov     hWndList+[ebx], eax
      .if ShowGrid == 0
            mov     eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES
      .else
            mov     eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES
      .endif
      INVOKE     SendMessage, hWndList+[ebx], LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax

;----- [Initialize the columns] -----
         mov     lvcol.imask, LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
         mov     ebx, SavList
         mov     lvcol.fmt, LVCFMT_LEFT
       MOVmd     lvcol.lx, ColName
         mov     lvcol.pszText, offset szColName
         mov     lvcol.iSubItem, COL_NAME 
      INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_NAME, addr lvcol

         mov     ebx, SavList
         mov     lvcol.fmt, LVCFMT_LEFT
       MOVmd     lvcol.lx, ColExt
         mov     lvcol.pszText, offset szColExt
         mov     lvcol.iSubItem, COL_EXT
      INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_EXT, addr lvcol

         mov     ebx, SavList
         mov     lvcol.fmt, LVCFMT_RIGHT
       MOVmd     lvcol.lx, ColSize
         mov     lvcol.pszText, offset szColSize
         mov     lvcol.iSubItem, COL_SIZE
      INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_SIZE, addr lvcol

         mov     ebx, SavList
         mov     lvcol.fmt, LVCFMT_LEFT
       MOVmd     lvcol.lx, ColDate
         mov     lvcol.pszText, offset szColDate
         mov     lvcol.iSubItem, COL_DATE
      INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_DATE, addr lvcol

         mov     ebx, SavList
         mov     lvcol.fmt, LVCFMT_LEFT
       MOVmd     lvcol.lx, ColAttr
         mov     lvcol.pszText, offset szColAttr
         mov     lvcol.iSubItem, COL_ATTR
      INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_ATTR, addr lvcol
         mov     ebx, SavList

         ;mov     lvcol.fmt, LVCFMT_LEFT
       ;MOVmd     lvcol.lx, ColType ;60
         ;mov     lvcol.pszText, offset szColType
         ;mov     lvcol.iSubItem, COL_TYPE
      ;INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTCOLUMN, COL_TYPE, addr lvcol 
        
                            
;----- [Get the shell image list for the list view] -----
         cmp     SavList, 4
         je      ret_ok 
      INVOKE     SHGetFileInfo, addr szRootPath, 0, addr sfi, sizeof SHFILEINFO, SHGFI_SYSICONINDEX or SHGFI_SMALLICON
        test     eax, eax
         jz      ret_error
         mov     hListImageList, eax

      INVOKE     LoadIcon, hInst, IDI_BACK
      INVOKE     ImageList_ReplaceIcon, hListImageList, 5, eax

      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 1, 4
         mov     hColImageList, eax

      INVOKE     SendMessage, hWndListL, LVM_GETHEADER, 0, 0  ; Retrieves column handle
         mov     hColL, eax 
      INVOKE     SendMessage, hWndListR, LVM_GETHEADER, 0, 0  ; Retrieves column handle
         mov     hColR, eax 

      INVOKE     LoadIcon, hInst, 9005  ; Up arrow
      INVOKE     ImageList_AddIcon, hColImageList, eax
         mov     UD, eax

      INVOKE     LoadIcon, hInst, 9006  ; Down arrow
      INVOKE     ImageList_AddIcon, hColImageList, eax
         mov     UD+4, eax
      INVOKE     SendMessage, hColL, HDM_SETIMAGELIST, 0, hColImageList
      INVOKE     SendMessage, hColR, HDM_SETIMAGELIST, 0, hColImageList

ret_ok:
         pop     SavList
         ret

ret_error:
         xor     eax, eax
         ret
InitListView     endp

;=========================================================================|
; UpdateListView PROCEDURE                                                |
;=========================================================================|
align DWORD
UpdateListView proc uses ebx edx hWnd:DWORD, pidlRoot:DWORD, pshfParent:DWORD ;LPSHELLFOLDER
LOCAL      lvi         :LV_ITEM
LOCAL      peidl       :DWORD ;LPENUMIDLIST
LOCAL      pidl        :DWORD ;LPITEMIDLIST
LOCAL      pidlFull    :DWORD ;LPITEMIDLIST
LOCAL      plvobj      :LPLV_OBJDATA
LOCAL      dwAttr      :DWORD
LOCAL      szExt[4]    :BYTE
LOCAL      SpszText    :DWORD, NoItem
LOCAL      Fold        :DWORD, dwFlags, Lcnt

.if StaticCnt == 22
      and     StaticCnt, 0
      ;jmp     pass
      push    hWndP
      pop     bri.hwndOwner
      ;;push    pidl
      ;;pop     bri.pidlRoot
      mov     bri.pidlRoot, 0
      lea     eax, szBuff
      mov     bri.pszDisplayName, eax
      mov     bri.ulFlags, BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN
   INVOKE     SHBrowseForFolder, addr bri
      mov     ebx, eax   ; eax = pidl
   INVOKE     SHGetPathFromIDList, ebx, addr szPath
   INVOKE     MessageBox,NULL, addr szPath, offset szListViewName, MB_OK
   INVOKE     MessageBox,NULL, addr szBuff, offset szListViewName, MB_OK
pass:
      jmp     ret_ok
.endif

         mov     Fold, 0
;--------------- [Remove all the items] ---------------
      .if SavList == 0
            mov     SavList, 4
      .endif
         mov     ebx, SavList  
      INVOKE     SendMessage, hWndList+[ebx], LVM_DELETEALLITEMS, 0, 0
;--------------- [Clear the varibles] ---------------
         and     ListTotN, 0
         and     ListTotS, 0
         and     ListSelN, 0
         and     ListSelS, 0
         and     ItemNum, 0
         and     NoItem, 0

      .if hFontL == 0
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameS
            mov     lf.lfHeight, -9 ;-10
            mov     lf.lfWidth, 0
            mov     lf.lfWeight, 600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontL,eax
      .endif
      .if DoColor
            and     DoColor, 0
         INVOKE     SendMessage, hWndListL, WM_SETFONT, hFontL, 1
         INVOKE     SendMessage, hWndListL, LVM_SETTEXTCOLOR, 0, TextC
         INVOKE     SendMessage, hWndListL, LVM_SETTEXTBKCOLOR, 0, TextBC
         INVOKE     SendMessage, hWndListL, LVM_SETBKCOLOR, 0, BackGC
         INVOKE     SendMessage, hWndListR, WM_SETFONT, hFontL, 1
         INVOKE     SendMessage, hWndListR, LVM_SETTEXTCOLOR, 0, TextC
         INVOKE     SendMessage, hWndListR, LVM_SETTEXTBKCOLOR, 0, TextBC
         INVOKE     SendMessage, hWndListR, LVM_SETBKCOLOR, 0, BackGC
      .endif

;SHCONTF_FOLDERS         equ 32
;SHCONTF_NONFOLDERS      equ 64
;SHCONTF_INCLUDEHIDDEN   equ 128

      .if ShowHidden == 1
            mov     dwFlags, SHCONTF_FOLDERS or SHCONTF_NONFOLDERS or SHCONTF_INCLUDEHIDDEN
      .else
            mov     dwFlags, SHCONTF_FOLDERS or SHCONTF_NONFOLDERS
      .endif

;--------------- [Get the id lists from the parent folder] --------------- 
         mov     edx, pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder ptr [edx]).EnumObjects, pshfParent, hWnd, dwFlags, addr peidl
        test     eax, eax
         js      ret_error

;--------------- [Display hourglass cursor] ---------------
      INVOKE     LoadCursor, NULL, IDC_WAIT
      INVOKE     SetCursor, eax

;--------------- [Set the LV_ITEM for callback] ---------------
         mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
         mov     lvi.iSubItem, 0
         mov     lvi.cchTextMax, 255
         mov     lvi.iImage, I_IMAGECALLBACK
         mov     lvi.pszText, LPSTR_TEXTCALLBACK

FillLoop:
         mov     edx, peidl
         mov     edx, [edx]
      INVOKE     (IEnumIDList ptr [edx]).Next, peidl, 1, addr pidl, NULL
        test     eax, eax
         js      ret_error

      .if eax == S_FALSE && ItemNum == 0
         .if ShowHidden == 0 && sw1 == 0 || FromTree ; If sw1 == 4 it means expansion
            INVOKE     StatusBar, 0, 0, 0, 0
               jmp     ret_ok
         .endif

;--------------- [For empty drive 'A' or 'B'] ---------------
            xor     edx, edx
            mov     dl, SavPath
         .if edx < 91
               add     edx, 32  ; Change to lower case
         .endif
         .if dl < 'c'
               jmp     ret_ok
         .endif

            or      NoItem, 1
            jmp     DoBack
      .endif

         cmp     eax, S_FALSE    ; No more items
         jz      End_ObjectLoop

         mov     eax, pShellMalloc
         mov     eax, [eax]
      INVOKE     (IMalloc ptr [eax]).Alloc, pShellMalloc, sizeof LV_OBJDATA ; Size = 24 bytes
      .if eax != 0
            mov     plvobj, eax  ; Memory pointer

;--------------- [Get full pidl] ---------------
         INVOKE     IDList_Combine, pidlRoot, pidl
           test     eax, eax
            jz      ret_error
            mov     pidlFull, eax


; Works ok, but takes two long to load
  
;               INVOKE     SHGetPathFromIDList, pidlFull, addr szPath ; This doesn't add that much time
;               INVOKE     GetFileAttributes, addr szPath
;DSPValue hWndP, eax
;INVOKE     MessageBox,NULL, addr szPath, offset szListViewName, MB_OK
;               INVOKE     FindFirstFile, addr szPath, addr FindData ; Get the file information
;                 test     eax, eax
;                   js     NoGo
;               INVOKE     FindClose, eax
;               INVOKE     lstrcmpi, addr FindData.cFileName, addr szRecyc ; Recycle folder
;                 test     eax,eax
;                  jz      FillLoop
;               .if ShowHidden == 0 && (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN or FILE_ATTRIBUTE_SYSTEM)
;                     jmp     FillLoop
;               .endif
;NoGo:
;--------------- [Get the file or folder attribute] ---------------
            mov     edx, pshfParent
            mov     edx, [edx]
         INVOKE     (IShellFolder ptr [edx]).GetAttributesOf, pshfParent, 1, addr pidl, addr dwAttr
           test     eax,eax
            js      ret_error
         .if dwAttr == 20000177h  ; File
            INVOKE     SHGetFileInfo, pidlFull, 0, addr shfi, sizeof SHFILEINFO,
                       SHGFI_PIDL or SHGFI_DISPLAYNAME ;or SHGFI_TYPENAME causes a problem
              test     eax,eax
               jz      ret_error
            INVOKE     lstrcmpi, addr shfi.szDisplayName, addr szRecyc ; Recycle folder
              test     eax,eax
               jz      FillLoop
         .endif

         .if dwAttr == 60000177h  ; Folder
               mov     Fold, 1
         .endif

;+++++++++++++++++++++++++++ [Builds the go back item] +++++++++++++++++++++++++++
DoBack:
         .if sw1 == 4
               and     sw1, 0
               mov     eax, pShellMalloc
               mov     eax, [eax]
            INVOKE     (IMalloc ptr [eax]).Alloc, pShellMalloc, sizeof LV_OBJDATA ; Size = 24 bytes
            .if eax == 0
                  jmp     ret_error
            .endif
               mov     hlvobj, eax

             MOVmd     lvi.iItem, ItemNum
               mov     lvi.iSubItem, 0
               mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
               mov     lvi.cchTextMax, 255
               lea     eax, szBack
               mov     lvi.pszText, eax
               mov     lvi.iImage, 5
             MOVmd     lvi.lParam, hlvobj

;--------------- [Add item to the list] ---------------
               mov     ebx, SavList
            INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTITEM, 0, addr lvi
               cmp     eax, -1
               jz      ret_error

;--------------- [Save LV_OBJDATA struct] ---------------
               mov     edx, hlvobj
            INVOKE     IDList_CopyItem, pidl
               mov     (LV_OBJDATA PTR [edx]).pidlRel, eax
               mov     eax, pshfParent
               mov     (LV_OBJDATA ptr [edx]).pshfParent, eax 
               mov     eax, pidlFull
               mov     (LV_OBJDATA ptr [edx]).pidlFull, eax    
               mov     eax, 20000000h
               mov     (LV_OBJDATA ptr [edx]).dwAttr, eax
               mov     eax, ItemNum
               mov     (LV_OBJDATA ptr [edx]).iItem, eax

;--------------- [Reset the fields] ---------------
               mov     Lcnt, 1
               mov     lvi.imask, LVIF_TEXT          
            .while (Lcnt < 5)
               .if Lcnt == 1
                     mov     eax, 0
               .elseif Lcnt == 2
                     lea     eax, szDir
               .elseif Lcnt == 3
                     lea     eax, szDate
               .elseif Lcnt == 4
                     lea     eax, szFill
               .endif
                MOVmd     lvi.iSubItem, Lcnt
                  mov     lvi.pszText, eax
                  mov     ebx, SavList
               INVOKE     SendMessage, hWndList+[ebx], LVM_SETITEMTEXT, 0, addr lvi
                  add     Lcnt, 1
            .endw
               cmp     eax, -1
               jz      ret_error

            .if NoItem              ; Empty dir
                  jmp     End_ObjectLoop
            .endif

;--------------- [Reset the LV_ITEM for callback] ---------------
               mov     lvi.iSubItem, 0
               mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
               mov     lvi.iImage, I_IMAGECALLBACK
               mov     lvi.pszText, LPSTR_TEXTCALLBACK
               add     ItemNum, 1
         .endif
;+++++++++++++++++++++++++++ [End of GoBack] +++++++++++++++++++++++++++

;--------------- [Save LV_OBJDATA struct] ---------------
            mov     edx, plvobj
         INVOKE     IDList_CopyItem, pidl
            mov     (LV_OBJDATA PTR [edx]).pidlRel, eax
            mov     eax, pshfParent                    
            mov     (LV_OBJDATA ptr [edx]).pshfParent, eax
            mov     eax, pidlFull
            mov     (LV_OBJDATA ptr [edx]).pidlFull, eax
            mov     eax, dwAttr
            mov     (LV_OBJDATA ptr [edx]).dwAttr, eax
            mov     eax, ItemNum
            mov     (LV_OBJDATA ptr [edx]).iItem, eax
            mov     lvi.lParam, edx

;--------------- [Add refernece to parent folder] ---------------
            mov     eax, (LV_OBJDATA ptr [edx]).pshfParent
            mov     eax, [eax]
         INVOKE     (IShellFolder ptr [eax]).AddRef, (LV_OBJDATA ptr [edx]).pshfParent

;--------------- [Add item to the list] ---------------
            mov     eax, ItemNum
            mov     lvi.iItem, eax
            mov     ebx, SavList  
         INVOKE     SendMessage, hWndList+[ebx], LVM_INSERTITEM, 0, addr lvi
            cmp     eax, -1
            jz      ret_error
            add     ItemNum, 1

;***************** I don't think this is freeing everything ****************
;--------------- [Free the resource] ---------------
         mov     eax, pShellMalloc
         mov     eax,[eax]
      INVOKE     (IMalloc PTR [eax]).Free, pShellMalloc, pidl

      .endif
         jmp     FillLoop

End_ObjectLoop:

;--------------- [Check to see if one of the List Views is a desktop item] ---------------
         lea     eax, offset szPathL+1
         lea     ebx, offset szPathR+1
      .if byte ptr [eax] != ':' || byte ptr [ebx] != ':'
            mov     KillThread, 1 ; Kill the auto list refresh thread
            jmp     NoSet
      .endif

;--------------- [Reset the refresh thread handles] ---------------
      .if SavList == 4
         .if hChange > 0
      INVOKE     FindCloseChangeNotification, hChange
         .endif
      INVOKE     lstrlen, addr szPathL
         sub     eax, 2
      INVOKE     lstrcpyn, addr szBuff, addr szPathL, eax
      INVOKE     FindFirstChangeNotification, addr szBuff, FALSE, FILE_NOTIFY_CHANGE_LAST_WRITE
         mov     hChange, eax
      .endif

      .if SavList == 8
         .if hChange+4 > 0
      INVOKE     FindCloseChangeNotification, hChange+4
         .endif
      INVOKE     lstrlen, addr szPathR
         sub     eax, 2
      INVOKE     lstrcpyn, addr szBuff, addr szPathR, eax
      INVOKE     FindFirstChangeNotification, addr szBuff, FALSE, FILE_NOTIFY_CHANGE_LAST_WRITE
         mov     hChange+4, eax
      .endif

      .if Funct == 0 && ThreadID == 0 && KillThread == 0
;           call     CreateThd   ; Causes NT loop find out why
      .endif

NoSet:
      .if SavList == 4
         INVOKE     lstrcpy, addr SavPath, addr szPathL
      .else
         INVOKE     lstrcpy, addr SavPath, addr szPathR
      .endif

;--------------- [Get the file totals] ---------------
      INVOKE     FindFirstFile, addr SavPath, addr FindData
        test     eax, eax
          js     ret_ok
         mov     hFind, eax
         jmp     Addem
Getem:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
         jz      AllDone
Addem:
      .if ShowHidden == 0 && (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN or FILE_ATTRIBUTE_SYSTEM)
            jmp     Getem
      .endif

      .if ShowHidden == 0
         INVOKE     lstrlen, addr FindData.cFileName
            sub     eax, 4
            lea     ebx, FindData.cFileName
            add     ebx, eax
             .if dword ptr[ebx] == 'lld.' || dword ptr[ebx] == 'LLD.'
               jmp     Getem
             .endif
      .endif

         mov     eax, MAXDWORD
         mov     ebx, FindData.nFileSizeHigh
        imul     ebx
         add     eax, FindData.nFileSizeLow
         add     ListTotS, eax
      .if eax > 0
            add     ListTotN, 1
      .endif
         jmp     Getem

AllDone:
      INVOKE     FindClose, hFind
   .if SavList == 4
       MOVmd     ListTotNL, ListTotN
       MOVmd     ListTotSL, ListTotS
       MOVmd     ListSelN, ListSelNL
       MOVmd     ListSelS, ListSelSL
   .else
       MOVmd     ListTotNR, ListTotN
       MOVmd     ListTotSR, ListTotS
       MOVmd     ListSelN, ListSelNR
       MOVmd     ListSelS, ListSelSR
   .endif

      INVOKE     StatusBar, ListSelS, ListTotS, ListSelN, ListTotN

;--------------- [Free resource and do initial sort] ---------------
         mov     ebx, peidl
         mov     ebx, [ebx]
      INVOKE     (IEnumIDList ptr [ebx]).Release, peidl

         mov     ebx, SavList
        push     SortCol+[ebx]
        push     SortAD+[ebx]
      .if ListTotN > 500
            mov     SortCol+[ebx], 0
            mov     SortAD+[ebx], 0
      .endif

         mov     sw1, 1
         and     sw2, 0
         mov     ebx, SavList
      INVOKE     SendMessage, hWndList+[ebx], LVM_SORTITEMS, SortCol+[ebx], addr ListViewSort
         mov     ebx, SavList
         pop     SortAD+[ebx]
         pop     SortCol+[ebx]

;--------------- [Resequence LV_OBJDATA.iItem] ---------------
         mov     ebx, SavList  
      INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEMCOUNT, 0, 0
         mov     Cnt, eax
         mov     Val, 0
         mov     lvi.iSubItem, 0
         mov     lvi.imask, LVIF_PARAM

         .while (Cnt > 0) 
             MOVmd     lvi.iItem, Val
               mov     ebx, SavList  
            INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi
               mov     ebx, lvi.lParam
             MOVmd     (LV_OBJDATA ptr [ebx]).iItem, Val
               add     Val, 1
               sub     Cnt, 1
         .endw

      .if !Fold
            jmp     NoFolder
      .endif
         mov     sw1, 1
         mov     sw2, 1       ; Sort folders
         mov     ebx, SavList  
        push     SortCol+[ebx]
        push     SortAD+[ebx]
         mov     SortCol+[ebx], 0
         mov     SortAD+[ebx], 0
         mov     ebx, SavList  
      INVOKE     SendMessage, hWndList+[ebx], LVM_SORTITEMS, SortCol+[ebx], addr ListViewSort
         mov     ebx, SavList  
         pop     SortAD+[ebx]
         pop     SortCol+[ebx]
         and     sw2, 0

NoFolder:

;--------------- [Reset to a normal cursor] ---------------
      INVOKE     LoadCursor, NULL, IDC_ARROW
      INVOKE     SetCursor, eax

;--------------- [Set the acsending and desending indicators] ---------------

         mov     eax, hListImageList
         mov     ebx, SavList
      INVOKE     SendMessage, hWndList+[ebx], LVM_SETIMAGELIST, LVSIL_SMALL, eax

         mov     eax, hColImageList
         mov     ebx, SavList
      INVOKE     SendMessage, hCol+[ebx], HDM_SETIMAGELIST, 0, eax
         mov     ebx, SavList

         mov     hd.imask, HDI_IMAGE or HDI_FORMAT
         mov     hd.fmt, HDF_STRING or HDF_LEFT or HDF_IMAGE or HDF_BITMAP_ON_RIGHT
         mov     ebx, SavList
      .if SortCol+[ebx] == 2
            mov     hd.fmt, HDF_STRING or HDF_RIGHT or HDF_IMAGE or HDF_BITMAP_ON_RIGHT
      .endif
         mov     eax, UD+4   ; Down icon
         mov     ebx, SavList
      .if SortAD+[ebx] == 1
            dec     eax      ; Up icon
      .endif
         mov     hd.iImage, eax
         mov     ebx, SavList
      INVOKE     SendMessage, hCol+[ebx], HDM_SETITEM, SortCol+[ebx], addr hd

ret_ok:
;--------------- [Set focus for the proper item] ---------------
      .if SavList == 4
            mov     eax, LevCntL
            xor     ebx, ebx
            mov     bl, byte ptr BackHighLiteL[eax]
      .else
            mov     eax, LevCntR
            xor     ebx, ebx
            mov     bl, byte ptr BackHighLiteR[eax]
      .endif

      .if bl == 0ffh
            xor     ebx, ebx
      .endif
        push     ebx
         mov     lvi.iItem, ebx
         mov     lvi.iSubItem, 0
         mov     lvi.imask, LVIF_STATE
         mov     lvi.state, LVIS_FOCUSED  ;LVIS_FOCUSED or LVIS_SELECTED
         mov     lvi.stateMask, 0fh
         mov     ebx, 4
      .if SavList == 8
            mov     ebx, 8
      .endif
         pop     ecx
      INVOKE     SendMessage, hWndList+[ebx], LVM_SETITEMSTATE, ecx, addr lvi
         mov     eax, 1
         ret

ret_error:              
         xor    eax, eax
         ret
UpdateListView endp

;=========================================================================|
; CopyData PROCEDURE                                                      |
;=========================================================================|
CopyData proc    slist:DWORD, stvobj:DWORD, sshf:DWORD
      .if slist == 8
            mov     LevCntR, 0
      .else
            mov     LevCntL, 0
      .endif

       MOVmd     SavList, slist
         ret
CopyData endp

;=========================================================================|
; ListViewNotify PROCEDURE                                                |
;=========================================================================|
align DWORD
ListViewNotify proc uses ebx ecx edx edi hWnd:DWORD, pnmlv:DWORD, ListLR:DWORD
LOCAL      pt:POINT
LOCAL      lvhit:LV_HITTESTINFO
LOCAL      lvi:LV_ITEM
LOCAL      plvobj:LPLV_OBJDATA
LOCAL      sei:SHELLEXECUTEINFO
;LOCAL      szString[150]:BYTE
LOCAL      szExt[4]:BYTE
;LOCAL      szPath[256]:BYTE
LOCAL      szListFolder[256]:BYTE
LOCAL      pidlFull:LPITEMIDLIST
LOCAL      dwAttr:DWORD
LOCAL      Img:DWORD
LOCAL      SubItem:DWORD, SavCol, pchEaten

LOCAL      ptvobj:LPTV_OBJDATA

         mov     eax, pnmlv                            ; pnmlv = lParam
         cmp     eax, 7003                             ; Enter key
         je      DBclicked
         mov     eax, (NM_LISTVIEW ptr [eax]).hdr.code
         cmp     eax, NM_RCLICK
         je      clicked
         cmp     eax, NM_DBLCLK
         je      DBclicked

      .if eax == LVN_SETDISPINFO
      .endif

      .if eax == LVN_GETDISPINFO                       ; Fill the list view
            mov     eax, pnmlv
            mov     ebx, (LV_DISPINFO ptr [eax]).hdr.hwndFrom
         .if ebx == hWndListL
               mov     ListLR, 4
         .elseif ebx == hWndListR
               mov     ListLR, 8
         .endif

            mov     eax, pnmlv
          MOVmd     SubItem, (LV_DISPINFO ptr [eax]).item.iSubItem
            mov     ecx, (LV_DISPINFO ptr [eax]).item.iItem
            mov     lvi.imask, LVIF_PARAM
            mov     lvi.iItem, ecx
            mov     ebx, ListLR                       ; Left or right view
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi
            mov     ebx, lvi.lParam
            mov     plvobj, ebx
            mov     edx, (LV_OBJDATA ptr [ebx]).dwAttr   ;!!!!!! D I E S when using GoBack sw1=4 from tree view
            mov     dwAttr, edx
            mov     edx, (LV_OBJDATA ptr [ebx]).pidlFull
            mov     pidlFull, edx

         .if  SubItem == 0
            INVOKE     GetIcon, pidlFull, 0
               mov     Img, eax
         .endif

         .if  SubItem == 0 || SubItem == 1
            INVOKE     SHGetFileInfo, pidlFull, 0, addr shfi, sizeof SHFILEINFO,
                       SHGFI_PIDL or SHGFI_DISPLAYNAME ;or SHGFI_ATTRIBUTES ; SHGFI_TYPENAME causes a problem
              test     eax,eax
               jz      ret_error
; For .pif extension
            INVOKE     lstrlen, addr shfi.szDisplayName
               sub     eax, 5
               lea     edi, shfi.szDisplayName
               add     edi, eax              ; Start address in input buffer
               mov     ecx, 5
               mov     al, 2eh               ; Period
               cld                           ; Increment edi
             repnz     scasb                 ; Repeat until byte = al('.')
            .if ecx == 0
               INVOKE     SHGetPathFromIDList, pidlFull, addr szPath
               INVOKE     FindFirstFile, addr szPath, addr FindData ; Get the file information
                 test     eax, eax
                   js     NoFile
               INVOKE     FindClose, eax
                  lea     eax, FindData.cFileName
                  jmp     GotIt
            .endif
         .endif

NoFile:
            lea     eax, shfi.szDisplayName
GotIt:
         .if SubItem == 0
               mov     ebx, pnmlv
               or      (LV_DISPINFO ptr [ebx]).item.imask, LVIF_DI_SETITEM
             MOVmd     (LV_DISPINFO ptr [ebx]).item.iImage, Img
               mov     (LV_DISPINFO ptr [ebx]).item.cchTextMax, 255
               mov     (LV_DISPINFO ptr [ebx]).item.pszText, eax
               jmp     ret_ok
         .endif

            mov     ebx, pnmlv
            mov     edx, (LV_DISPINFO ptr [ebx]).item.imask
         .if edx == LVIF_IMAGE  ;2
               jmp     ret_ok
         .endif

         .if SubItem == 1  ; Extension
            INVOKE     lstrcpy, addr szPath, eax
            INVOKE     lstrcpy, addr szExt, addr Clear
            INVOKE     lstrlen, addr szPath
               sub     eax, 5
               lea     edi, szPath
               add     edi, eax              ; Start address in input buffer
               mov     ecx, 5
               mov     al, 2eh               ; Period
               cld                           ; Increment edi
             repnz     scasb                 ; Repeat until byte = al('.')
            .if ecx > 0
               INVOKE     lstrcpyn, addr szExt, edi, 5
            .endif

            .if dwAttr == 60000177h          ; Clear Ext if folder has a period in its name
               INVOKE     lstrcpy, addr szExt, addr Clear
            .endif
               lea     eax, szExt
               mov     ebx, pnmlv
               or      (LV_DISPINFO ptr [ebx]).item.imask, LVIF_DI_SETITEM
               mov     (LV_DISPINFO ptr [ebx]).item.cchTextMax, 255
               mov     (LV_DISPINFO ptr [ebx]).item.pszText, eax
               jmp     ret_ok
         .endif

         INVOKE     SHGetPathFromIDList, pidlFull, addr szPath
         INVOKE     FindFirstFile, addr szPath, addr FindData ; Get the file information
           test     eax, eax
             js     ret_ok
            mov     hFind, eax

         .if SubItem == 2                   ; File Size
               mov     eax, MAXDWORD
               mov     ebx, FindData.nFileSizeHigh
              imul     ebx
               add     eax, FindData.nFileSizeLow
               mov     edx, eax
            INVOKE     BaseAscii, edx, addr szString, 10, 10, 1, 0, 1
               mov     ebx, pnmlv
               or      (LV_DISPINFO ptr [ebx]).item.imask, LVIF_DI_SETITEM
               mov     (LV_DISPINFO ptr [ebx]).item.cchTextMax, 255

            .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
                  lea     eax, szDir
            .else
                  lea     eax, szString
            .endif  
               mov     (LV_DISPINFO ptr [ebx]).item.pszText, eax
            INVOKE     FindClose, hFind
               jmp     ret_ok
         .endif

         .if SubItem == 3                  ; FileTime
            INVOKE     FileTimeToSystemTime, offset FindData.ftLastWriteTime, offset time
            INVOKE     fmtime, time.SYSTEMTIME
               mov     ebx, pnmlv
               or      (LV_DISPINFO ptr [ebx]).item.imask, LVIF_DI_SETITEM
               mov     (LV_DISPINFO ptr [ebx]).item.cchTextMax, 255
               mov     (LV_DISPINFO ptr [ebx]).item.pszText, eax       ; eax = cdt.dmo from DATETIME struct
            INVOKE     FindClose, hFind
               jmp     ret_ok
         .endif
 
         .if SubItem == 4                 ; Attributes
            INVOKE     lstrcpy, addr szArc, addr szFill
               mov     ebx, offset szArc
            .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
                  mov     byte ptr[ebx], 'r'
            .endif
            .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE)
                  mov     byte ptr[ebx+1], 'a'
            .endif
            .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)
                  mov     byte ptr[ebx+2], 'h'
            .endif
            .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)
                  mov     byte ptr[ebx+3], 's'
            .endif
               mov     ebx, pnmlv
               or      (LV_DISPINFO ptr [ebx]).item.imask, LVIF_DI_SETITEM
               mov     (LV_DISPINFO ptr [ebx]).item.cchTextMax, 255
               lea     eax, szArc
               mov     (LV_DISPINFO ptr [ebx]).item.pszText, eax
            INVOKE     FindClose, hFind
         .endif
            jmp     ret_ok
      .endif

      .if eax == LVN_COLUMNCLICK
; Display hourglass cursor and sort columns
         INVOKE     LoadCursor, NULL, IDC_WAIT
         INVOKE     SetCursor, eax
            mov     eax, pnmlv
            mov     edx, (NM_LISTVIEW ptr [eax]).iSubItem
            mov     ebx, ListLR  
            and     Cnt, 0
          MOVmd     SavCol, SortCol+[ebx]
         .if SortAD+[ebx] == 0 && edx == SortCol+[ebx]
               or      SortAD+[ebx], 1
         .elseif SortAD+[ebx] == 1 && edx == SortCol+[ebx]
               and     SortAD+[ebx], 0
         .endif
            mov     SortCol+[ebx], edx
            or      sw1, 1
            and     sw2, 0
            mov     ebx, ListLR  
         INVOKE     SendMessage, hWndList+[ebx], LVM_SORTITEMS, SortCol+[ebx], addr ListViewSort

; Resequence LV_OBJDATA.iItem
            mov     ebx, ListLR  
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEMCOUNT, 0, 0
            mov     Cnt, eax
            mov     Val, 0
            mov     lvi.iSubItem, 0
            mov     lvi.imask, LVIF_PARAM
         .while (Cnt > 0) 
             MOVmd     lvi.iItem, Val
            mov     ebx, ListLR  
            INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi
               mov     ebx, lvi.lParam
             MOVmd     (LV_OBJDATA ptr [ebx]).iItem, Val
               add     Val, 1
               sub     Cnt, 1
         .endw
            mov     ebx, ListLR  
         INVOKE     SendMessage, hWndList+[ebx], LVM_SORTITEMS, SortCol+[ebx], addr ListViewSort
; Reset to a normal cursor
         INVOKE     LoadCursor, NULL, IDC_ARROW
         INVOKE     SetCursor, eax

; Set the column acsending and desending indicators
;------------------------------------------------------------------------------
            mov     ebx, ListLR
            mov     lvcol.imask, LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT
            lea     eax, szBuff
            mov     lvcol.pszText, eax
            mov     lvcol.cchTextMax, 255
          MOVmd     lvcol.iSubItem, SavCol
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETCOLUMN, SavCol, addr lvcol
         INVOKE     lstrlen, addr szBuff
            sub     eax, 1
         INVOKE     lstrcpyn, addr szBuff, addr szBuff, eax

            mov     ebx, ListLR
         .if SavCol == 0
              INVOKE     lstrcpy, addr szBuff, addr szColName
         .elseif SavCol == 1
              INVOKE     lstrcpy, addr szBuff, addr szColExt
         .elseif SavCol == 2
              INVOKE     lstrcpy, addr szBuff, addr szColSize
         .elseif SavCol == 3
              INVOKE     lstrcpy, addr szBuff, addr szColDate
         .elseif SavCol == 4
              INVOKE     lstrcpy, addr szBuff, addr szColAttr
         .endif
            mov     ebx, ListLR
            mov     lvcol.imask, LVCF_SUBITEM or LVCF_TEXT or LVCF_FMT
            mov     lvcol.fmt, LVCFMT_LEFT
         .if SavCol == 2
               mov     lvcol.fmt, LVCFMT_RIGHT
         .endif
            mov     lvcol.pszText, offset szBuff
          MOVmd     lvcol.iSubItem, SavCol
         INVOKE     SendMessage, hWndList+[ebx], LVM_SETCOLUMN, SavCol, addr lvcol

            mov     eax, hColImageList
            mov     ebx, ListLR
         INVOKE     SendMessage, hCol+[ebx], HDM_SETIMAGELIST, 0, eax
            mov     ebx, ListLR
   
            mov     hd.imask, HDI_IMAGE or HDI_FORMAT
            mov     hd.fmt, HDF_STRING or HDF_LEFT or HDF_IMAGE or HDF_BITMAP_ON_RIGHT
         .if SortCol+[ebx] == 2
               mov     hd.fmt, HDF_STRING or HDF_RIGHT or HDF_IMAGE or HDF_BITMAP_ON_RIGHT
         .endif
            mov     eax, UD+4   ; Down icon
            mov     ebx, ListLR
         .if SortAD+[ebx] == 1
               dec     eax      ; Up icon
         .endif
            mov     hd.iImage, eax
            mov     ebx, ListLR
         INVOKE     SendMessage, hCol+[ebx], HDM_SETITEM, SortCol+[ebx], addr hd
      .endif
         jmp     ret_ok

DBclicked:
         mov     sw1, 4        ; Used for go back icon
         jmp     clicked

clicked:
      .if eax == 7003          ; Enter key
            mov     ebx, ListLR
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETNEXTITEM, -1, LVNI_SELECTED
            mov     lvhit.iItem, eax
            mov     lvhit.flags, LVHT_ONITEM
            jmp     FromEnterKey
      .endif 

      INVOKE     GetCursorPos, addr pt
         mov     ebx, ListLR
      INVOKE     ScreenToClient, hWndList+[ebx], addr pt
         mov     eax, pt.x
         mov     lvhit.pt.x, eax
         mov     eax, pt.y
         mov     lvhit.pt.y, eax

         mov     ebx, ListLR
      INVOKE     SendMessage, hWndList+[ebx], LVM_HITTEST, 0, addr lvhit

FromEnterKey:
; Clicked on an item or enter key
      .if (lvhit.flags & LVHT_ONITEM)
            mov     ebx, ListLR
         INVOKE     ClientToScreen, hWndList+[ebx], addr pt
            mov     lvi.imask, LVIF_PARAM or LVIF_TEXT
            mov     eax, lvhit.iItem
            mov     lvi.iItem, eax
            lea     eax, szListFolder
            mov     lvi.pszText, eax
            mov     lvi.cchTextMax, 255
            mov     lvi.iSubItem, 0
            mov     ebx, ListLR
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi
           test     eax,eax
            jz      ret_error
            mov     eax, lvi.lParam
            mov     plvobj, eax
            mov     ebx, pnmlv
            cmp     ebx, 7003          ; Enter key
            je      EnterKey
            mov     ebx, (NM_LISTVIEW ptr [ebx]).hdr.code

         .if ebx == NM_RCLICK          ; Right clicked open context menu

               INVOKE     lstrlen, addr szListFolder
                  sub     eax, 4
                  lea     ebx, szListFolder
                  add     ebx, eax
               INVOKE     lstrcmpi, ebx, addr szZip
               .if eax == 0            ; zip file
                     mov     sw2, 10   ; Hide the zip console
               .endif

               and     Cmd, 0
               mov     ebx, plvobj
            INVOKE     ContextMenu, hWnd, (LV_OBJDATA ptr [ebx]).pshfParent, (LV_OBJDATA ptr [ebx]).pidlRel, addr pt

;---------------------------- [Open] --------------------------
            .if Cmd == 104
               INVOKE     lstrlen, addr szListFolder
                  sub     eax, 4
                  lea     ebx, szListFolder
                  add     ebx, eax
               INVOKE     lstrcmpi, ebx, addr szZip
               .if eax == 0            ; zip file
                     mov     edx, plvobj
                     mov     ebx, (LV_OBJDATA ptr [edx]).pidlFull
                  INVOKE     SHGetPathFromIDList, ebx, addr SavDlgPath
                  INVOKE     SendMessage, hWndP, WM_COMMAND, 403, 403  ; UnPack
                     jmp     ret_ok
               .endif
            .endif

;---------------------------- [Delete] --------------------------
            .if Cmd == 18
               .if ListLR == 4
                     mov     ListSelSL, 0
                     mov     ListSelNL, 0
               .else
                     mov     ListSelNR, 0
                     mov     ListSelSR, 0
               .endif
               INVOKE     ListViewRefresh, ListLR
            .endif

;---------------------------- [Cut or Copy] --------------------------
            .if Cmd == 25 || Cmd == 26
                MOVmd     HoldCmd, Cmd
                MOVmd     PasteCmd, Cmd
                MOVmd     HoldPos, ListLR
            .endif

;---------------------------- [Paste] --------------------------
            .if Cmd == 63
                MOVmd     SavList, HoldPos
                  and     HoldPos, 0
               .if HoldCmd == 25
                     and     HoldCmd, 0
                  INVOKE     SendMessage, hWndP, WM_COMMAND, 105, 0  ; From Move
               .elseif HoldCmd == 26
                     and     HoldCmd, 0
                  INVOKE     SendMessage, hWndP, WM_COMMAND, 104, 0  ; From Copy
               .else
                  INVOKE     MessageBox, NULL, addr szNoCutCopy, addr szListViewName, MB_OK or MB_ICONWARNING ;or MB_TASKMODAL
               .endif
            .endif

;---------------------------- [Rename] --------------------------
            .if Cmd == 64
                  mov     ebx, ListLR
               INVOKE     SendMessage, hWndList+[ebx], LVM_EDITLABEL, lvi.iItem, 0
                 test     eax, eax
                  jz      ret_error
            .endif

;---------------------------- [User Edit] --------------------------
            .if Cmd == 65
               .if EditPgr != 0 && EditPgr != ' '
                     mov     ebx, plvobj
                     mov     edx, (LV_OBJDATA ptr [ebx]).pidlFull
                  INVOKE     SHGetPathFromIDList, edx, addr szPath
                  INVOKE     lstrcpy, addr szString, addr EditPgr
                  INVOKE     lstrcat, addr szString, addr szSpace
                  INVOKE     lstrcat, addr szString, addr szPath
                  INVOKE     WinExec, addr szString, SW_SHOWNORMAL     ;Exec a program
               .else
                  INVOKE     MessageBox, NULL, addr szEditError, addr szListViewName, MB_OK or MB_ICONWARNING
               .endif
               .if eax < 32
                     ; error
               .endif
            .endif
         .else                         ; Double clicked

EnterKey:
            .if word ptr szListFolder == '.['

; -------------------- [Collapse the folder] --------------------

               .if ListLR == 4
                  INVOKE     lstrcpy, addr szPath, addr szPathL
                     mov     eax, LevCntL
                     mov     byte ptr BackHighLiteL+[eax], 0  ; GoBack highlight
                  .if eax == 1                                ; Root level
                        and     sw1, 0
                        and     LevCntL, 0
                        mov     RestoreL, 0ffh                ; Terminator
                  .else
                        sub     LevCntL, 1
                        mov     eax, LevCntL
                        lea     edx, RestoreL
                        mov     byte ptr [edx+eax], 0ffh
                  .endif
               .else
                  INVOKE     lstrcpy, addr szPath, addr szPathR
                     mov     eax, LevCntR
                     mov     byte ptr BackHighLiteR+[eax], 0  ; GoBack highlight
                  .if eax == 1                                ; Root level
                        and     sw1, 0
                        and     LevCntR, 0
                        mov     RestoreR, 0ffh                ; Terminator
                  .else
                        sub     LevCntR, 1
                        mov     eax, LevCntR
                        lea     edx, RestoreR
                        mov     byte ptr [edx+eax], 0ffh
                  .endif
               .endif

               INVOKE     lstrlen, addr szPath
                  sub     eax, 3
               INVOKE     lstrcpyn, addr szPath, addr szPath, eax
               INVOKE     lstrlen, addr szPath
                  mov     ecx, eax
                  lea     esi, szPath
                  add     esi, eax
               .while (ecx)                  ; Get the previous level path
                  .if byte ptr[esi] == '\'
                        inc     eax
                     INVOKE     lstrcpyn, addr SavPath, addr szPath, eax
                     INVOKE     lstrcat, addr SavPath, addr szBackS
                     .break
                  .endif
                  dec     eax
                  dec     ecx
                  dec     esi
               .endw
                 call     PathToPidl

               INVOKE     lstrcat, addr SavPath, addr szAllFiles
               .if ListLR == 4
                  INVOKE     lstrcpy, addr szPathL, addr SavPath
               .else
                  INVOKE     lstrcpy, addr szPathR, addr SavPath
               .endif

                  mov     ebx, ListLR
               INVOKE     UpdateListView, hWndList+[ebx], pidlBase, pshf
                 test     eax,eax
                  jz      ret_error
                  mov     eax, pshf
                  mov     eax, [eax]
               INVOKE     (IShellFolder ptr [eax]).Release, pshf
               INVOKE     UpdateSelBars
                  jmp     ExpCol
            .endif

               mov     ebx, plvobj
               mov     eax, (LV_OBJDATA ptr [ebx]).dwAttr

            .if (eax & SFGAO_FOLDER)

; -------------------- [Expand the folder] --------------------

               .if ListLR == 8
                     mov     eax, LevCntR
                     mov     ebx, lvi.iItem
                     mov     byte ptr BackHighLiteR+[eax], bl  ; GoBack highlight
                     add     LevCntR, 1
                     mov     ebx, LevCntR
                     lea     edx, RestoreR                     ; Used for startup
               .else
                     mov     eax, LevCntL
                     mov     ebx, lvi.iItem
                     mov     byte ptr BackHighLiteL+[eax], bl  ; GoBack highlight
                     add     LevCntL, 1
                     mov     ebx, LevCntL
                     lea     edx, RestoreL                     ; Used for startup
               .endif

                  mov     eax, ebx                      ;LevCnt
                  mov     esi, ebx
                  dec     esi
                  mov     ebx, lvi.iItem
                  mov     byte ptr [edx+esi], bl
                  mov     dword ptr [edx+eax], 000000ffh
                  mov     edx, plvobj
                  mov     ebx, (LV_OBJDATA ptr [edx]).pidlFull
                  mov     pidlBase, ebx                 ; Save for combine pidl's

               INVOKE     SHGetPathFromIDList, ebx, addr SavPath
               INVOKE     lstrcat, addr SavPath, addr szBackS
               INVOKE     lstrcat, addr SavPath, addr szAllFiles
               .if ListLR == 8
                  INVOKE     lstrcpy, addr szPathR, addr SavPath
               .else
                  INVOKE     lstrcpy, addr szPathL, addr SavPath
               .endif

                  mov     ebx, plvobj
                  mov     edx, (LV_OBJDATA ptr [ebx]).pshfParent
                  mov     edx, [edx]

               INVOKE     (IShellFolder PTR [edx]).BindToObject, 
                          (LV_OBJDATA ptr [ebx]).pshfParent, 
                          (LV_OBJDATA ptr [ebx]).pidlRel, 0, addr IID_IShellFolder, addr pshf
                 test     eax, eax
                  js      ret_error

                  mov     ebx, ListLR
               INVOKE     UpdateListView, hWndList+[ebx], pidlBase, pshf
                 test     eax,eax
                  jz      ret_error
                  mov     eax, pshf
                  mov     eax, [eax]
               INVOKE     (IShellFolder ptr [eax]).Release, pshf
               INVOKE     UpdateSelBars

ExpCol:
      .if ListLR == 4
         INVOKE     ExpColTree, SavButtL, 0   ; 1 = expand, 0 = collaspe
         INVOKE     ExpColTree, SavButtL, 1   ; 1 = expand, 0 = collaspe
      .elseif ListLR == 8
         INVOKE     ExpColTree, SavButtR, 0   ; 1 = expand, 0 = collaspe
         INVOKE     ExpColTree, SavButtR, 1   ; 1 = expand, 0 = collaspe
      .endif

                  jmp     ret_ok
            .else

; -------------------- [Its a executable or a association file or zip] --------------------

               .if SavList == 4
                  INVOKE     lstrcpy, addr szString, addr szPathL
               .elseif SavList == 8
                  INVOKE     lstrcpy, addr szString, addr szPathR
               .endif
               INVOKE     lstrlen, addr szString
                  sub     eax, 2
               INVOKE     lstrcpyn, addr szString, addr szString, eax

               INVOKE     lstrlen, addr szListFolder
                  sub     eax, 4
                  lea     ebx, szListFolder
                  add     ebx, eax
               INVOKE     lstrcmpi, ebx, addr szZip
               .if eax == 0            ; zip file
                  INVOKE     SendMessage, hWndP, WM_COMMAND, 403, 403  ; UnPack
                     jmp     ret_ok
               .endif

                  mov     ebx, plvobj
                  mov     sei.cbSize, sizeof SHELLEXECUTEINFO
                  mov     sei.fMask, SEE_MASK_INVOKEIDLIST
                  mov     eax, hWnd
                  mov     sei.hwnd, eax
                  mov     sei.lpVerb, offset szOpen
                  mov     sei.lpFile, offset szNull
                  mov     sei.lpParameters, offset szNull
                  lea     eax, szString
                  mov     sei.lpDirectory, eax  ;offset szNull
                  mov     sei.nShow, SW_SHOWNORMAL
                  mov     sei.hInstApp, 0
                  mov     eax, (LV_OBJDATA ptr [ebx]).pidlFull
                  mov     sei.lpIDList, eax
                  mov     sei.lpClass, 0
                  mov     sei.dwHotKey, 0
                  mov     sei.hIcon, 0
                  mov     sei.hProcess, 0
               INVOKE     ShellExecuteEx, addr sei
            .endif
         .endif
      .else
; For future use
      .endif
        
ret_ok:
         mov     eax, 1
         ret
ret_error:
         xor     eax, eax
         ret        
ListViewNotify endp

;=========================================================================|
; ListViewRestore PROCEDURE                                               |
;=========================================================================|
ListViewRestore proc uses ebx ecx ebx esi ListLR:DWORD

; -------------------- [Expand the folder] --------------------
      INVOKE     lstrcpy, addr BackHighLiteL, addr RestoreL
      INVOKE     lstrcpy, addr BackHighLiteR, addr RestoreR
      .if ListLR == 4
         INVOKE     lstrcpy, addr SavPath, addr szPathL
      .else
         INVOKE     lstrcpy, addr SavPath, addr szPathR
      .endif

      INVOKE     lstrlen, addr SavPath
         sub     eax, 2
      INVOKE     lstrcpyn, addr SavPath, addr SavPath, eax

      INVOKE     lstrlen, addr SavPath
         mov     ecx, eax
         lea     esi, SavPath
         xor     ecx, ecx
      .while (eax)                ; Find the number of levels for the path
         .if byte ptr[esi] == '\'
               inc     ecx
         .endif
         dec     eax
         inc     esi
      .endw
      .if ecx > 0
            dec     ecx
      .endif
         and     sw1, 0
      .if ecx
            mov     sw1, 4
      .endif       
      .if ListLR == 4
            mov     LevCntL, ecx
      .else
            mov     LevCntR, ecx
      .endif

;------------ [Bind to that folder] ------------
      INVOKE     PathToPidl
      INVOKE     lstrcat, addr SavPath, addr szAllFiles

         mov     ebx, ListLR
      INVOKE     UpdateListView, hWndList+[ebx], pidlBase, pshf
        test     eax,eax
         jz      ret_error
         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
         and     sw1, 0
         jmp     ret_ok

ret_ok:
         mov     eax, 1
         ret

ret_error:
         xor     eax, eax
         ret        
ListViewRestore endp

;=========================================================================|
; ListViewRefresh PROCEDURE                                               |
;=========================================================================|
ListViewRefresh proc uses ebx  ListLR:DWORD

         mov     sw1, 4
      .if ListLR == 4
         INVOKE     lstrcpy, addr szPath, addr szPathL
            mov     eax, LevCntL
      .else
         INVOKE     lstrcpy, addr szPath, addr szPathR
            mov     eax, LevCntR
      .endif
      .if eax == 0                                   ; Root level
            and     sw1, 0
      .endif
      INVOKE     lstrlen, addr szPath
         sub     eax, 2
      INVOKE     lstrcpyn, addr SavPath, addr szPath, eax
        call     PathToPidl

      INVOKE     lstrcat, addr SavPath, addr szAllFiles
      .if ListLR == 4
         INVOKE     lstrcpy, addr szPathL, addr SavPath
      .else
         INVOKE     lstrcpy, addr szPathR, addr SavPath
      .endif

         mov     ebx, ListLR
      INVOKE     UpdateListView, hWndList+[ebx], pidlBase, pshf
        test     eax,eax
         jz      ret_error
         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
      INVOKE     UpdateSelBars
         jmp     ret_ok

ret_ok:
         mov     eax, 1
         ret

ret_error:
         xor     eax, eax
         ret        
ListViewRefresh endp

;=========================================================================|
; Get a pidl from a Path PROCEDURE                                        |
;=========================================================================|
PathToPidl proc uses edx
LOCAL      pchEaten:DWORD

;-------------- [Converts ASCII to UNICODE] -------------
      INVOKE     MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr SavPath, -1, addr szBuff, 255
      INVOKE     SHGetDesktopFolder, addr pshf
        test     eax,eax
         js      ret_error

;-------------- [Creates a pidl from a path] -------------
         mov     edx, pshf
         mov     edx, [edx]
      INVOKE     (IShellFolder ptr [edx]).ParseDisplayName, pshf, hWndP, 0, addr szBuff, addr pchEaten, addr pidlBase, 0
        test     eax, eax
         js      ret_error

;-------------- [Bindes the folder] -------------
         mov     edx, pshf
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).BindToObject, pshf, pidlBase,
                 0, addr IID_IShellFolder, addr pshf
        test     eax, eax
         js      ret_error

ret_ok:
         mov     eax, 1
         ret

ret_error:
         xor     eax, eax
         ret        
PathToPidl endp

;=========================================================================|
; StatusBar PROCEDURE                                                     |
;=========================================================================|
StatusBar proc  listSelS:DWORD, listTotS:DWORD, listSelN:DWORD, listTotN:DWORD

      INVOKE     BaseAscii, listSelS, addr szWork, 1, 10, 1, 1, 1
      INVOKE     lstrcpy, addr szStatus, addr szWork
      INVOKE     lstrcat, addr szStatus, addr szOf

      INVOKE     BaseAscii, listTotS, addr szWork, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szWork
      INVOKE     lstrcat, addr szStatus, addr szIn

      INVOKE     BaseAscii, listSelN, addr szWork, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szWork
      INVOKE     lstrcat, addr szStatus, addr szOf

      INVOKE     BaseAscii, listTotN, addr szWork, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szWork
      INVOKE     lstrcat, addr szStatus, addr szFiles

   .if SavList == 4
      INVOKE     lstrcpy, addr szStatusL, addr szStatus
      INVOKE     SendMessage, hWndStatusBar, SB_SETTEXT, 1, addr szStatusL
   .else
      INVOKE     lstrcpy, addr szStatusR, addr szStatus
      INVOKE     SendMessage, hWndStatusBar, SB_SETTEXT, 2, addr szStatusR
   .endif
         ret        
StatusBar endp

;=========================================================================|
; ListViewSort PROCEDURE                                                  |
;=========================================================================|
ListViewSort proc uses ebx edx ecx esi edi plvobj1:DWORD, plvobj2:DWORD, lParamSort:DWORD
;LOCAL    strret:STRRET
LOCAL    lvi:LV_ITEM
LOCAL    Comp[256]:BYTE
LOCAL    Comp1[256]:BYTE
LOCAL    Comp2[256]:BYTE
LOCAL    Work[20]:BYTE
LOCAL    Savesi:DWORD

      .if ((plvobj1 != 0) && (plvobj2 != 0))
            mov     ebx, plvobj1
            mov     eax, (LV_OBJDATA ptr [ebx]).dwAttr
            mov     ebx, plvobj2
            mov     edx, (LV_OBJDATA ptr [ebx]).dwAttr
         .if sw2 == 1       ; Sort folders
               jmp     ChkFold
         .endif
         .if (eax & SFGAO_FOLDER) && !(edx & SFGAO_FOLDER)
               xor     eax, eax
               dec     eax
               ret
         .elseif (edx & SFGAO_FOLDER) && !(eax & SFGAO_FOLDER)
               xor     eax, eax
               inc     eax
               ret
         .elseif (eax & SFGAO_FOLDER) && (edx & SFGAO_FOLDER)
               xor     eax, eax
               ret
         .endif
            jmp     LoopC

ChkFold:
         .if !(eax & SFGAO_FOLDER)
               xor     eax, eax
               ret
         .elseif !(edx & SFGAO_FOLDER)
               xor     eax, eax
               ret
         .endif

LoopC:
         .if sw1 == 1    
               mov     edx, plvobj1
         .else
               mov     edx, plvobj2
         .endif
            mov     eax, (LV_OBJDATA ptr [edx]).iItem
            mov     ItemNum, eax
            mov     ebx, ItemNum
            mov     lvi.iItem, ebx
            mov     lvi.iSubItem, 0
            mov     lvi.imask, LVIF_TEXT
            lea     ebx, szBuff  
            mov     lvi.pszText, ebx
            mov     lvi.cchTextMax, 255
            mov     ebx, SavList
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi

            mov     ebx, ItemNum
            mov     lvi.iItem, ebx
            mov     ebx, lParamSort
            mov     lvi.iSubItem, ebx
            mov     lvi.imask, LVIF_PARAM or LVIF_TEXT
         .if sw1 == 1 
               lea     ebx, Comp1
         .else
               lea     ebx, Comp2
         .endif
            mov     lvi.pszText, ebx
            mov     lvi.cchTextMax, 255
            mov     ebx, SavList
         INVOKE     SendMessage, hWndList+[ebx], LVM_GETITEM, 0, addr lvi
         INVOKE     lstrcpy, addr Comp, lvi.pszText

         .if lParamSort == 3       ; Rearrange the date fields
            INVOKE     lstrcpy, addr Work, addr Comp+6
            INVOKE     lstrcpyn, addr Work+4, addr Comp, 6
            INVOKE     lstrcpyn, addr Work+9, addr Comp+11, 9
            .if sw1 == 1
               INVOKE     lstrcpy, addr Comp1, addr Work
            .else
               INVOKE     lstrcpy, addr Comp2, addr Work
            .endif
         .endif

         .if lParamSort == 2       ; Fill size with leading zeros
            INVOKE     lstrcpy, addr Work, addr Zeros
            INVOKE     lstrlen, addr Comp
               mov     ebx, 10
               sub     ebx, eax
            INVOKE     lstrcpy, addr Work[ebx], addr Comp
            .if sw1 == 1
               INVOKE     lstrcpy, addr Comp1, addr Work
            .else
               INVOKE     lstrcpy, addr Comp2, addr Work
            .endif
         .endif
         .if sw1 == 1
               lea     eax, Comp1
         .else
               lea     eax, Comp2
         .endif
         .if lParamSort > 0
            INVOKE     lstrcat, eax, offset szBuff
         .endif
         .if sw1 == 1
               mov     Savesi, eax
               mov     sw1, 2
               jmp     LoopC
         .else
               mov     edi, eax
               mov     esi, Savesi
               mov     sw1, 1
         .endif

         INVOKE     CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE or SORT_STRINGSORT, esi, 20, edi, 20
;         INVOKE     CompareString, LOCALE_SYSTEM_DEFAULT, NORM_IGNORECASE or SORT_STRINGSORT, esi, 20, edi, 20
            mov     ebx, SavList
         .if eax == 1 && SortAD+[ebx] == 1  ; SortAD = 1 = desending sort
               mov     eax, 1
         .elseif eax == 3 && SortAD+[ebx] == 1
               mov     eax, -1
         .else
            .if eax == 1
               mov     eax, -1
            .elseif eax == 3
               mov     eax, 1
            .else
               xor     eax, eax
            .endif
         .endif
      .endif
         ret
ListViewSort endp

END                   
;INVOKE     MessageBox,NULL, addr szListViewName, offset szListViewName, MB_OK
