         title    Registry

         .586
         .model   flat, STDCALL

         option   casemap: none   ; case sensitive
         include  FileMan.inc

.const                               ; Constant data segment

szFileMan    db      'File Manager V1',0
szREGSZ      db      'REG_SZ',0
szViewFlags  db      '[View Flags]',0
szSavList    db      'Active View',0
szAutoTree   db      'Auto tree enabled',0
szBackGC     db      'Color Background',0
szTextC      db      'Color Text',0
szTextBC     db      'Color Text Background',0
szColName    db      'Col 0 Name Width', 0 
szColExt     db      'Col 1 Ext Width', 0
szColSize    db      'Col 2 Size Width', 0
szColDate    db      'Col 3 Date Width', 0
szColAttr    db      'Col 4 Attr Width', 0
szColType    db      'Col 5 Type Width', 0
szCopyToRec  db      'Copy del files to recycle',0  
szDrvLeft    db      'Drive Left View',0
szDrvRight   db      'Drive Right View',0
szEditPgr    db      'Edit Program',0
szFontName   db      'Font Name',0
szPointSize  db      'Font Point Size',0
szFontSize   db      'Font Size',0
szFontWeight db      'Font Weight',0
szList4L     db      'List View 4 Left',0
szList4R     db      'List View 4 Right',0
szList8L     db      'List View 8 Left',0
szList8R     db      'List View 8 Right',0
szLeft       db      'Pos1 Left',0
szTop        db      'Pos2 Top',0
szRight      db      'Pos3 Right',0
szBottom     db      'Pos4 Bottom',0
szRestoreL   db      'Restore Left',0
szRestoreR   db      'Restore Right',0
szResPathL   db      'Ret Path Left',0
szResPathR   db      'Ret Path Right',0
szTabSelect  db      'Tab Control Selection',0
szSaveExit   db      'Save Settings On Exit',0
szSepLeft    db      'Septerator Left',0
szSepRight   db      'Septerator Right',0
szGrid       db      'Show Grid Lines',0
szHidden     db      'Show Hidden Files',0
szProcessed  db      'Show Processed Msg',0
szSortADL    db      'Sort Left view A-D',0
szSortADR    db      'Sort Right view A-D',0
szSortColL   db      'Sort Left view Column',0
szSortColR   db      'Sort Right view Column',0
szTreeWth    db      'Tree View Width',0
szChkZip     db      'Use Programmed ZipUnZip program',0
szZipPack    db      'Zip Pack Program',0
szZipUnPack  db      'Zip UnPack Program',0
szPgmZip     db      'ZipUnZip Programmed Program',0

combobox     db      'COMBOBOX',0
listbox      db      'LISTBOX',0
ToolClass    db      'ToolbarWindow32',0
butt         db      'BUTTON',0
szRootPath   db      'C:\',0
szDrvC       db      'C:\*.*',0 
szAssoc      db      '*.exe *.dll *.com *.bat *.pif *.ico',0,'*.exe;*.dll;*.com;*.bat;*.pif;*.ico',0,
                     'All Files',0,'*.*',0,0
szLbrak      db      '[',0
szRbrak      db      ']   ',0
szLparen     db      '  (',0
szRparen     db      ')',0
szBackS      db      '\',0
szComma      db      ',',0
szNone       db      ' none This will  D E L E T E  the extension key!',0
szSpace      db      '  ',0
szUFile      db      '_file',0
szBFile      db      ' file',0
szOpen       db      'open',0
szPercent1   db      ' %1',0
szZero       db      ',0',0
szExe        db      '.exe',0
szDll        db      '.dll',0
szIco        db      '.ico',0
szRegIcon    db      '\DefaultIcon',0
szRegShell   db      '\shell',0
szRegOpen    db      '\open',0
szRegCmd     db      '\command',0
szRegSEC     db      '\shell\edit\command',0
szRegSOC     db      '\shell\open\command',0
szRegSPC     db      '\shell\print\command',0
szNoSelect   db      'You need to make a selection first.',0
szNoAssoc    db      'There was no association for the selected extension.',0

.data                                ; Initialized & uninitialized data
lpType       dd      0
lpcbData     dd      0
lpdwDisp     dd      0
PAD          db      32  dup(?),0

SaveExit     dd      1
ViewFlags    dd      1
TreeVWidth   dd      144

hReg         dd      0
hAssoc       dd      0
hCombo       dd      0
hList        dd      0
hTB          dd      0
hIcon1       dd      0
hIcon2       dd      0
hSingleImage dd      0
hButtE       dd      0
hButtI       dd      0
DelKey       dd      0
Num          dd      0
szNum        db      4   dup(?),0 
szBuff       db      256 dup(?),0
szRegPath    db      256 dup(?),0
szRegValue   db      256 dup(?),0
szRegSave    db      256 dup(?),0
szIconPath   db      256 dup(?),0
szOpenPath   db      256 dup(?),0
szIconTemp   db      256 dup(?),0
szRegExt     db      10  dup(?),0
szExtent     db      10  dup(?),0
szFileName   db      80  dup(?),0

rect         RECT         <?>
ft           FILETIME     <>
lf           LOGFONT      <?>
ofn          OPENFILENAME <?>

.code

;========================================================================|
;* Initialize PROCEDURE                                                  |
;========================================================================|
Initialize PROC
LOCAL    hRegKey:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szFileMan, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegKey, offset lpdwDisp
         mov     lpcbData, 4
         mov     eax, offset szViewFlags
         lea     ebx, ViewFlags
      INVOKE     RegQueryValueEx, hRegKey, eax, 0, offset lpType, ebx, offset lpcbData
         cmp     eax, 0
         je      NotFirst

      INVOKE     RegSet, offset szViewFlags, ViewFlags
      INVOKE     RegSet, offset szTreeWth, TreeVWidth
      INVOKE     RegSet, offset szDrvLeft, SavButtL
      INVOKE     RegSet, offset szDrvRight, SavButtR
      INVOKE     RegSet, offset szSavList, SavList

         mov     lpcbData, 25
      INVOKE     RegSetValueEx, hRegKey, offset szFontName, 0, REG_SZ, offset FontNameS, lpcbData
         mov     lpcbData, 20
      INVOKE     RegSetValueEx, hRegKey, offset szRestoreL, 0, REG_BINARY, offset RestoreL, lpcbData
         mov     lpcbData, 20
      INVOKE     RegSetValueEx, hRegKey, offset szRestoreR, 0, REG_BINARY, offset RestoreR, lpcbData
         mov     lpcbData, 149
      INVOKE     RegSetValueEx, hRegKey, offset szResPathL, 0, REG_SZ, offset szDrvC, lpcbData
         mov     lpcbData, 149
      INVOKE     RegSetValueEx, hRegKey, offset szResPathR, 0, REG_SZ, offset szDrvC, lpcbData

NotFirst:
      INVOKE     RegQuery, offset szColName, ColName
         mov     ColName, eax
      INVOKE     RegQuery, offset szColExt, ColExt
         mov     ColExt, eax
      INVOKE     RegQuery, offset szColSize, ColSize
         mov     ColSize, eax
      INVOKE     RegQuery, offset szColDate, ColDate
         mov     ColDate, eax
      INVOKE     RegQuery, offset szColAttr, ColAttr
         mov     ColAttr, eax
      INVOKE     RegQuery, offset szColType, ColType
         mov     ColType, eax
      INVOKE     RegQuery, offset szViewFlags, ViewFlags
         mov     ViewFlags, eax
      INVOKE     RegQuery, offset szTreeWth, TreeVWidth
         mov     TreeVWidth, eax
      INVOKE     RegQuery, offset szSepLeft, SeparatorLeft
         mov     SeparatorLeft, eax
      INVOKE     RegQuery, offset szSepRight, SeparatorRight
         mov     SeparatorRight, eax
      INVOKE     RegQuery, offset szDrvLeft, SavButtL
         mov     SavButtL, eax
      INVOKE     RegQuery, offset szDrvRight, SavButtR
         mov     SavButtR, eax
      INVOKE     RegQuery, offset szSavList, SavList
      .if eax == 4 || eax == 8
      .else
            mov     eax, 4
      .endif
         mov     SavList, eax
      INVOKE     RegQuery, offset szGrid, ShowGrid
         mov     ShowGrid, eax
      INVOKE     RegQuery, offset szHidden, ShowHidden
         mov     ShowHidden, eax
      INVOKE     RegQuery, offset szProcessed, ShowProcessed
         mov     ShowProcessed, eax
      INVOKE     RegQuery, offset szChkZip, ChkZip
         mov     ChkZip, eax
      INVOKE     RegQuery, offset szAutoTree, AutoTree
         mov     AutoTree, eax
      INVOKE     RegQuery, offset szSortADL, SortADL
         mov     SortADL, eax
      INVOKE     RegQuery, offset szSortADR, SortADR
         mov     SortADR, eax
      INVOKE     RegQuery, offset szSortColL, SortColL
         mov     SortColL, eax
      INVOKE     RegQuery, offset szSortColR, SortColR
         mov     SortColR, eax
      INVOKE     RegQuery, offset szBackGC, BackGC
         mov     BackGC, eax
      INVOKE     RegQuery, offset szTextC, TextC
         mov     TextC, eax
      INVOKE     RegQuery, offset szTextBC, TextBC
         mov     TextBC, eax
      INVOKE     RegQuery, offset szFontSize, FontS
         mov     FontS, eax
      INVOKE     RegQuery, offset szFontWeight, FontW
         mov     FontW, eax
      INVOKE     RegQuery, offset szPointSize, PointSize
         mov     PointSize, eax
      INVOKE     RegQuery, offset szSaveExit, SaveExit
         mov     SaveExit, eax
      INVOKE     RegQuery, offset szCopyToRec, CopyToRecycle
         mov     CopyToRecycle, eax
      INVOKE     RegQuery, offset szTabSelect, TabSelect
         mov     TabSelect, eax

         mov     lpcbData, 25
      INVOKE     RegQueryValueEx, hRegKey, offset szFontName, 0, offset lpType, offset FontName, offset lpcbData
         mov     lpcbData, 21
      INVOKE     RegQueryValueEx, hRegKey, offset szRestoreL, 0, offset lpType, offset RestoreL, offset lpcbData
         mov     lpcbData, 21
      INVOKE     RegQueryValueEx, hRegKey, offset szRestoreR, 0, offset lpType, offset RestoreR, offset lpcbData
         mov     lpcbData, 149
      INVOKE     RegQueryValueEx, hRegKey, offset szResPathL, 0, offset lpType, offset szPathL, offset lpcbData
.if byte ptr szPathL+1 != ':'
   INVOKE     lstrcpy, offset szPathL, offset szDrvC
      mov     byte ptr RestoreL, 0ffh
      mov     SavButtL, 1
.endif  
         mov     lpcbData, 149
      INVOKE     RegQueryValueEx, hRegKey, offset szResPathR, 0, offset lpType, offset szPathR, offset lpcbData
.if byte ptr szPathR+1 != ':'
   INVOKE     lstrcpy, offset szPathR, offset szDrvC
      mov     byte ptr RestoreR, 0ffh
      mov     SavButtR, 1
.endif  
         mov     lpcbData, 101
      INVOKE     RegQueryValueEx, hRegKey, offset szEditPgr, 0, offset lpType, offset EditPgr, offset lpcbData
         mov     lpcbData, 101
      INVOKE     RegQueryValueEx, hRegKey, offset szZipPack, 0, offset lpType, offset ZipPack, offset lpcbData
         mov     lpcbData, 101
      INVOKE     RegQueryValueEx, hRegKey, offset szZipUnPack, 0, offset lpType, offset ZipUnPack, offset lpcbData
         mov     lpcbData, 101
      INVOKE     RegQueryValueEx, hRegKey, offset szPgmZip, 0, offset lpType, offset PgmZip, offset lpcbData

      INVOKE     RegCloseKey, hRegKey

         RET
Initialize ENDP

;========================================================================|
;* RegSave Registry save PROCEDURE                                       |
;========================================================================|
RegSave PROC
LOCAL    hRegKey:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szFileMan, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegKey, offset lpdwDisp

      INVOKE     RegSet, offset szColName, ColName
      INVOKE     RegSet, offset szColExt, ColExt
      INVOKE     RegSet, offset szColSize, ColSize
      INVOKE     RegSet, offset szColDate, ColDate
      INVOKE     RegSet, offset szColAttr, ColAttr
      INVOKE     RegSet, offset szColType, ColType
      INVOKE     RegSet, offset szViewFlags, ViewFlags
      INVOKE     RegSet, offset szTreeWth, TreeVWidth
        call     GetDesktopWindow
      INVOKE     GetWindowRect, eax, offset rect
        push     rect.right
      INVOKE     GetWindowRect, hWndP, offset rect
         pop     eax
      .if eax < rect.right
           mov     rect.right, eax
      .endif
      .if rect.left > 7fffffffh
            mov     rect.left, 0
      .endif
      INVOKE     RegSet, offset szLeft, rect.left
      INVOKE     RegSet, offset szRight, rect.right
      INVOKE     RegSet, offset szTop, rect.top
      INVOKE     RegSet, offset szBottom, rect.bottom

      .if ViewFlags == 1 || ViewFlags == 3
            mov     SeparatorLeft, 0
      .endif
      .if ViewFlags == 1
         INVOKE     GetWindowRect, hWndP, offset rect
            mov     eax, rect.left
            sub     rect.right, eax
            mov     eax, rect.right
            shr     eax, 1
            sub     eax, 1
;            mov     SeparatorRight, eax  ; Centers the splitter bar
      .endif
      INVOKE     RegSet, offset szSepLeft, SeparatorLeft
      INVOKE     RegSet, offset szSepRight, SeparatorRight
      INVOKE     RegSet, offset szDrvLeft, SavButtL
      INVOKE     RegSet, offset szDrvRight, SavButtR
      INVOKE     RegSet, offset szSavList, SavList
      INVOKE     RegSet, offset szGrid, ShowGrid
      INVOKE     RegSet, offset szHidden, ShowHidden
      INVOKE     RegSet, offset szProcessed, ShowProcessed
      INVOKE     RegSet, offset szChkZip, ChkZip
      INVOKE     RegSet, offset szAutoTree, AutoTree
      INVOKE     RegSet, offset szSortADL, SortADL
      INVOKE     RegSet, offset szSortADR, SortADR
      INVOKE     RegSet, offset szSortColL, SortColL
      INVOKE     RegSet, offset szSortColR, SortColR
      INVOKE     RegSet, offset szBackGC, BackGC
      INVOKE     RegSet, offset szTextC, TextC
      INVOKE     RegSet, offset szTextBC, TextBC
      INVOKE     RegSet, offset szFontSize, FontS
      INVOKE     RegSet, offset szFontWeight, FontW
      INVOKE     RegSet, offset szPointSize, PointSize
      INVOKE     RegSet, offset szSaveExit, SaveExit
      INVOKE     RegSet, offset szCopyToRec, CopyToRecycle
      INVOKE     RegSet, offset szTabSelect, TabSelect

         mov     lpcbData, 25
      INVOKE     RegSetValueEx, hRegKey, offset szFontName, 0, REG_SZ, offset FontName, lpcbData
         mov     lpcbData, 20
      INVOKE     RegSetValueEx, hRegKey, offset szRestoreL, 0, REG_BINARY, offset RestoreL, lpcbData
         mov     lpcbData, 20
      INVOKE     RegSetValueEx, hRegKey, offset szRestoreR, 0, REG_BINARY, offset RestoreR, lpcbData
         mov     lpcbData, 149
      INVOKE     RegSetValueEx, hRegKey, offset szResPathL, 0, REG_SZ, offset szPathL, lpcbData
         mov     lpcbData, 149
      INVOKE     RegSetValueEx, hRegKey, offset szResPathR, 0, REG_SZ, offset szPathR, lpcbData
         mov     lpcbData, 100
      INVOKE     RegSetValueEx, hRegKey, offset szEditPgr, 0, REG_SZ, offset EditPgr, lpcbData
         mov     lpcbData, 100
      INVOKE     RegSetValueEx, hRegKey, offset szZipPack, 0, REG_SZ, offset ZipPack, lpcbData
         mov     lpcbData, 100
      INVOKE     RegSetValueEx, hRegKey, offset szZipUnPack, 0, REG_SZ, offset ZipUnPack, lpcbData
         mov     lpcbData, 100
      INVOKE     RegSetValueEx, hRegKey, offset szPgmZip, 0, REG_SZ, offset PgmZip, lpcbData

      INVOKE     RegCloseKey, hRegKey
         RET
RegSave ENDP

;=========================================================================|
;* Return the integer value in eax from the registry  PROCEDURE           |
;=========================================================================|
RegQuery PROC    szValueName:DWORD, Default:DWORD
      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szFileMan, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, offset hReg, offset lpdwDisp
         mov     lpcbData, 4
         mov     eax, szValueName
         lea     ebx, Default
      INVOKE     RegQueryValueEx, hReg, eax, 0, offset lpType, ebx, offset lpcbData
      INVOKE     RegCloseKey, hReg
         mov     eax, Default
         RET
RegQuery ENDP

;=========================================================================|
;* Sets the specified integer value in the registry PROCEDURE             |
;=========================================================================|
RegSet  PROC      szValueName:DWORD, Value:DWORD
      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szFileMan, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, offset hReg, offset lpdwDisp
         mov     lpcbData, 4
         mov     eax, szValueName
         lea     ebx, Value
      INVOKE     RegSetValueEx, hReg, eax, 0, REG_DWORD, ebx, lpcbData
      INVOKE     RegCloseKey, hReg
         RET
RegSet  ENDP

;========================================================================|
;* AssociationDlg File association PROCEDURE                             |
;========================================================================|

;!!!!!!!!!!!!!!!!!! WORKS, BUT NEEDS TO BE REWRITTEN !!!!!!!!!!!!!!!!!!
align DWORD
AssociationDlg PROC  USES ebx ecx esi edi hdlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
LOCAL     sfi       :SHFILEINFO
LOCAL     lvi       :LV_ITEM
LOCAL     szExt[10] :BYTE
LOCAL     szType[50]:BYTE
LOCAL     IndexNum  :DWORD, PathSize, ValueSize, TotCnt, hFontC, hDC, SavRet

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG
         jne     @1

       MOVmd     hAssoc, hdlg
         and     sw1, 0
         and     DelKey, 0
         mov     szIconPath, 0
         mov     szNum, 0
         mov     ebx, SavList
      INVOKE     SendMessage, hWndList+[ebx], LVM_GETSELECTEDCOUNT, 0, 0
      .if eax == 0                     ; No selection
         INVOKE     MessageBox, NULL, addr szNoSelect, addr szFileMan, MB_OK or MB_ICONWARNING or MB_TASKMODAL
            jmp     CancleIt
      .endif

      INVOKE     CreateWindowEx,NULL, addr butt,0,
                 WS_CHILD or WS_VISIBLE or BS_ICON,
                 387,16,30,30,hdlg,44,hInst,NULL
         mov     hButtE, eax

      INVOKE     CreateWindowEx,NULL, addr butt,0,
                 WS_CHILD or WS_VISIBLE or BS_ICON,
                 387,95,30,30,hdlg,45,hInst,NULL
         mov     hButtI, eax

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset combobox, 0,
                 WS_CHILD or WS_VISIBLE or WS_VSCROLL or CBS_HASSTRINGS or CBS_DROPDOWN or CBS_SORT or LBS_NOTIFY,
                 322,16,55,220, hdlg, 15, hInst, 0
         mov     hCombo, eax
      INVOKE     SendMessage, hCombo, CB_SETITEMHEIGHT, -1, 14
      INVOKE     SendMessage, hCombo, CB_SETITEMHEIGHT, 1, 14

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset listbox, 0,
                 WS_CHILD or WS_VISIBLE or WS_BORDER or SS_SUNKEN or LBS_STANDARD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_NOTIFY,
                 8,166,371,127, hdlg, 16, hInst, 0  ;8,86,371,127
         mov     hList, eax

      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameS
         mov     lf.lfHeight, -10
         mov     lf.lfWidth, 0
         mov     lf.lfWeight, 500
      INVOKE     CreateFontIndirect, addr lf
         mov     hFontC, eax
      INVOKE     SendMessage, hCombo, WM_SETFONT, hFontC, 1
      INVOKE     SendMessage, hList, WM_SETFONT, hFontC, 1

ReLoad:
      INVOKE     SendMessage, hCombo, CB_ADDSTRING, 0, addr szSpace
      INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szNone

         mov     TotCnt, 0
         mov     IndexNum, 0

LoopP:
      INVOKE     RegEnumKeyEx, HKEY_CLASSES_ROOT, IndexNum, offset szRegPath, addr PathSize, 0, offset szRegValue, addr ValueSize, addr ft
      .if eax == ERROR_NO_MORE_ITEMS
            jmp     NoMore
      .endif

      .if byte ptr szRegPath != 2eh || eax != 0
            add     IndexNum, 1
            mov     PathSize, 256
            mov     ValueSize, 256
            jmp     LoopP
      .endif     
      INVOKE     lstrcpy, addr szExt, addr szRegPath

         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegPath, offset szRegSave, addr lpcbData

         mov     lpcbData, 50
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegSave, addr szType, addr lpcbData
      .if eax != 0
            jmp     Pass
      .endif
      INVOKE     lstrcpy, offset szRegPath, offset szRegSave
      INVOKE     lstrcat, offset szRegPath, offset szRegSOC
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegPath, offset szRegValue, addr lpcbData
      .if eax != 0
            jmp     Pass
      .endif

      INVOKE     lstrcpy, addr szBuff, addr szLbrak
      INVOKE     lstrcat, addr szBuff, addr szExt
      INVOKE     lstrcat, addr szBuff, addr szRbrak
      INVOKE     lstrcat, addr szBuff, addr szType

      INVOKE     lstrcat, addr szBuff, addr szLparen
      INVOKE     lstrcat, addr szBuff, addr szRegValue
      INVOKE     lstrcat, addr szBuff, addr szRparen

      INVOKE     SendMessage, hCombo, CB_ADDSTRING, 0, addr szExt
      INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szBuff
         add     TotCnt, 1

Pass:
         add     IndexNum, 1
         mov     PathSize, 256
         mov     ValueSize, 256
         jmp     LoopP

NoMore:

         mov     word ptr szRegExt, 002eh
      INVOKE     lstrcpy, addr szBuff, addr SavDlgPath

      INVOKE     lstrlen, addr szBuff
         mov     ecx, eax
         lea     edi, szBuff
         mov     al, 2eh               ; Period
         cld                           ; Increment edi
       repnz     scasb                 ; Repeat until byte = al('.')
      .if ecx > 0
            dec     edi
         INVOKE     lstrcpy, addr szRegExt, edi
      .endif
         cmp     sw1, 8
         je      BuildPath
      INVOKE     SetDlgItemText, hdlg, 800, addr szRegExt  ; Display the source extension

BuildPath:
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegExt, offset szRegSave, addr lpcbData
;INVOKE     MessageBox,NULL, addr szRegSave, offset szFileMan, MB_OK

      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
      INVOKE     lstrcat, addr szRegValue, addr szRegIcon
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegValue, offset szIconPath, addr lpcbData
      INVOKE     lstrlen, addr szIconPath
         mov     ecx, eax
         lea     edi, szIconPath
         mov     al, 2ch               ; Comma
         cld                           ; Increment edi
       repnz     scasb                 ; Repeat until byte = al(',')
      .if ecx > 0
           push     ecx
         INVOKE     lstrcpy, addr szNum, edi
         INVOKE     lstrlen, addr szIconPath
            pop     ecx
            sub     eax, ecx
         INVOKE     lstrcpyn, addr szIconPath, addr szIconPath, eax
         .if byte ptr szIconPath == '"'
            INVOKE     lstrlen, addr szIconPath
               dec     eax
            INVOKE     lstrcpyn, addr szIconPath, addr szIconPath+1, eax
         .endif 
      .endif

;      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
;      INVOKE     lstrcat, addr szRegValue, addr szRegSOC
;         mov     lpcbData, 256
;      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegValue, offset szOpenPath, addr lpcbData
;INVOKE     MessageBox,NULL, addr szOpenPath, offset szFileMan, MB_OK

      INVOKE     SetDlgItemText, hdlg, 804, addr szNum
      INVOKE     SetDlgItemText, hdlg, 805, addr szIconPath

      INVOKE     SendMessage, hCombo, CB_FINDSTRING, -1, addr szRegExt
         mov     SavRet, eax

      .if eax == 0ffffffffh
         INVOKE     SetWindowText, hCombo, addr szRegExt
         INVOKE     SetDlgItemText, hdlg, 801, addr szNoAssoc
         INVOKE     SetDlgItemText, hdlg, 805, addr szNoAssoc
            jmp     DspIcon
      .endif

;SetEm:                                 ; Set the selection for the list & combo boxes
         mov     eax, SavRet
         and     DelKey, 0
        push     eax
      INVOKE     SendMessage, hList, LB_SETCURSEL, eax, 0
         pop     eax
        push     eax
      INVOKE     SendMessage, hCombo, CB_SETCURSEL, eax, 0
         pop     ebx
      INVOKE     SendMessage, hList, LB_GETTEXT, ebx, addr szBuff

      INVOKE     lstrcpy, addr szRegSave, addr szBuff
      INVOKE     lstrlen, addr szRegSave
         mov     ecx, eax
         lea     edi, szRegSave
         mov     al, 28h               ; (
         cld                           ; Increment edi
       repnz     scasb                 ; Repeat until byte = al('(')
      .if ecx > 0                      ; Strip the parentheses
         INVOKE     lstrcpy, addr szBuff, edi
         INVOKE     lstrlen, addr szBuff
         INVOKE     lstrcpyn, addr szBuff ,addr szBuff, eax
      .endif
      INVOKE     SetDlgItemText, hdlg, 801, addr szBuff

      .if byte ptr szBuff == 20h && byte ptr szBuff+1 == 6eh
            or      DelKey, 1
            mov     szRegPath, 0
      .endif

         xor     eax, eax
      .if byte ptr szBuff == '"' || byte ptr szBuff == '\'
            inc     eax
      .endif
      INVOKE     lstrcpy, addr szRegSave, addr szBuff+[eax]
      INVOKE     lstrcpy, addr szExtent, addr szExe
         and     Var, 0
;INVOKE     MessageBox,NULL, addr szRegSave, offset szFileMan, MB_OK

LoopC:
      INVOKE     lstrlen, addr szRegSave
         mov     ecx, eax
         lea     esi, szRegSave
      .while (ecx)
           push     esi  
           push     ecx
         INVOKE     CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, esi, 4, offset szExtent, 4
            pop     ecx
            pop     esi 
         .if eax == 2             ; 2 = match
               lea     eax, szRegSave
               sub     esi, eax
               add     esi, 5
            INVOKE     lstrcpyn, addr szRegSave, addr szRegSave, esi
            INVOKE     lstrcpy, addr szRegPath, addr szRegSave
               jmp     DspIcon
         .endif
            inc     esi
            dec     ecx
      .endw
         add     Var, 1
      .if Var < 3
         .if Var == 1
            INVOKE     lstrcpy, addr szExtent, addr szDll
         .else
            INVOKE     lstrcpy, addr szExtent, addr szIco
         .endif
            jmp     LoopC
      .endif

DspIcon:
      INVOKE     ImageList_Create, 24, 24, ILC_COLOR16 or ILC_MASK, 1, 2
         mov     hSingleImage, eax

      INVOKE     ExtractIcon, hInst, addr szIconPath, -1  ; 0 - n, -1 returns the total number of icons
      INVOKE     SetDlgItemInt, hdlg, 803, eax, 0
      INVOKE     GetDlgItemInt, hdlg, 804, 0, TRUE
      INVOKE     ExtractIcon, hInst, addr szIconPath, eax  ; 0 - n, -1 returns the total number of icons 
         mov     hIcon2, eax

      .if sw1 < 7                 ; From initial load
          MOVmd     hIcon1, SavIcon
            jmp     HaveIcon
      .endif
      .if sw1 == 9
         INVOKE     ExtractIcon, hInst, addr szIconPath, -1   ; 0 - n, -1 returns the total number of icons
         INVOKE     SetDlgItemInt, hdlg, 803, eax, 0
         INVOKE     GetDlgItemText, hdlg, 804, addr szNum, sizeof szNum
         INVOKE     GetDlgItemInt, hdlg, 804, 0, TRUE
         INVOKE     ExtractIcon, hInst, addr szIconPath, eax  ; 0 - n, -1 returns the total number of icons 
            mov     hIcon2, eax   ; Default icon
            jmp     HaveIcon
      .endif
      INVOKE     ExtractIcon, hInst, addr szRegSave, 0        ; 0 - n, -1 returns the total number of icons 
         mov     hIcon1, eax      ; Open icon

HaveIcon:
      INVOKE     ImageList_AddIcon, hSingleImage, hIcon1
      INVOKE     ImageList_AddIcon, hSingleImage, hIcon2
      INVOKE     DeleteObject, hIcon1
      INVOKE     DeleteObject, hIcon2

      INVOKE     ImageList_GetIcon, hSingleImage, 0, ILD_NORMAL
         mov     hIcon1, eax
      INVOKE     ImageList_GetIcon, hSingleImage, 1, ILD_NORMAL
         mov     hIcon2, eax
      .if sw1 != 9
         INVOKE     SendMessage, hButtE, BM_SETIMAGE, IMAGE_ICON, hIcon1
      .endif
      INVOKE     SendMessage, hButtI, BM_SETIMAGE, IMAGE_ICON, hIcon2
      INVOKE     DeleteObject, hIcon1
      INVOKE     DeleteObject, hIcon2
         jmp     DlgDone

@1:
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         jne     DlgDone               ; that was pressed
         mov     eax, wparam
         mov     ebx, eax
         shr     ebx, 16
      .if ebx == LBN_SELCHANGE
            and     eax, 0000ffffh
         .if eax == 15 
            INVOKE     SendMessage, hCombo, CB_GETCURSEL, 0, 0
         .else
            INVOKE     SendMessage, hList, LB_GETCURSEL, 0, 0
         .endif
            mov     SavRet, eax
         INVOKE     SendMessage, hList, LB_GETTEXT, eax, addr szBuff
            mov     eax, SavRet
         INVOKE     SendMessage, hCombo, CB_GETLBTEXT, eax, addr szRegExt
            mov     sw1, 8  
            jmp     BuildPath
      .endif

      .if eax == 11                     ; File association browse
            mov     sw1, 7
            jmp     OpenFileA
      .endif
      .if eax == 12                     ; Icon browse
            mov     sw1, 9
            jmp     OpenFileA
      .endif
      .if eax == 45                     ; Icon button
         INVOKE     GetDlgItemText, hdlg, 805, addr szIconPath, sizeof szIconPath
         INVOKE     GetDlgItem, hdlg, 804
         INVOKE     SetFocus, eax 
            mov     sw1, 9
            jmp     DspIcon
      .endif
      .if     eax == IDOK
         INVOKE     GetDlgItemText, hdlg, 800, addr szRegExt, sizeof szRegExt  ; Get extension
            jmp     Update
      .endif
         cmp     eax, IDCANCEL
         je      CancleIt
         jmp     DlgDone

OpenFileA:
      INVOKE     lstrcpy, addr szBuff, addr szIconPath
      INVOKE     SetCurrentDirectory, addr szBuff

         mov     ofn.lStructSize, sizeof ofn
       MOVmd     ofn.hWndOwner, hWndP
       MOVmd     ofn.hInstance, hInst
         mov     ofn.lpstrFilter, offset szAssoc
         mov     ofn.lpstrFile, offset szBuff
         mov     ofn.nMaxFile, lengthof szBuff
         mov     ofn.lpstrFileTitle, offset szFileName
         mov     ofn.nMaxFileTitle, lengthof szFileName
         mov     ofn.lpstrInitialDir, 0
         mov     ofn.lpstrTitle, 0
         mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
         mov     ofn.lpstrDefExt, 0
      INVOKE     GetOpenFileName, offset ofn
         cmp     eax, FALSE       ; Cancel'ed or error occurred
         je      DlgDone
      .if sw1 == 9                ; From the icon button
         INVOKE     SetDlgItemText, hdlg, 805, addr szBuff
         INVOKE     lstrcpy, addr szIconPath, addr szBuff
            jmp     DspIcon
      .endif
      INVOKE     lstrcpy, addr szRegSave, addr szBuff
      INVOKE     lstrcpy, addr szRegPath, addr szBuff
   INVOKE     lstrcat, offset szBuff, offset szPercent1
      INVOKE     SetDlgItemText, hdlg, 801, addr szBuff
         jmp     DspIcon

Update:
         cmp     szRegExt, 0
         je      DlgDone 
      .if sw1 != 7 && sw1 != 8 && sw1 != 9
            jmp     DlgDone
      .endif
      .if DelKey == 0
            jmp     AddChange
      .endif

;----------------[Delete the keys for the extension]-------------
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegExt ; Delete extension key

      INVOKE     lstrcpy, offset szRegValue, offset szRegExt+1
      INVOKE     lstrcat, offset szRegValue, offset szUFile
      INVOKE     lstrcpy, offset szRegSave, offset szRegValue
      INVOKE     lstrcat, offset szRegValue, offset szRegSOC
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegValue ; Delete command key

      INVOKE     lstrcpy, offset szRegValue, offset szRegSave
      INVOKE     lstrcat, offset szRegValue, offset szRegShell
      INVOKE     lstrcat, offset szRegValue, offset szRegOpen
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegValue ; Delete open key

      INVOKE     lstrcpy, offset szRegValue, offset szRegSave
      INVOKE     lstrcat, offset szRegValue, offset szRegShell
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegValue ; Delete shell key

      INVOKE     lstrcpy, offset szRegValue, offset szRegSave
      INVOKE     lstrcat, offset szRegValue, offset szRegIcon
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegValue ; Delete default icon key

      INVOKE     lstrcpy, offset szRegValue, offset szRegSave
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, offset szRegValue ; Delete file key
         and     sw1, 0
         and     DelKey, 0
         jmp     ReSet

         jmp     DlgDone

AddChange:
;----------------[Set the extentsion, .xxx]-------------
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, offset szRegExt, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, offset lpdwDisp

      INVOKE     lstrcpy, offset szRegValue, offset szRegExt+1
      INVOKE     lstrcat, offset szRegValue, offset szUFile
      INVOKE     lstrlen, offset szRegValue  ; szRegValue = xxx_file
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, offset szRegValue, eax
      INVOKE     RegCloseKey, hReg

;----------------[Set the extentsion pointer, xxx_file]-------------
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, offset szRegValue, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, offset lpdwDisp

      INVOKE     lstrcpy, offset szRegSave, offset szRegExt+1
      INVOKE     lstrcat, offset szRegSave, offset szBFile
      INVOKE     lstrlen, offset szRegSave  ; szRegSave = xxx file
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, offset szRegSave, eax
      INVOKE     RegCloseKey, hReg

;----------------[Set the \DefaultIcon, E:\xxxx\xxxx.exe,0]-------------
      INVOKE     lstrcpy, offset szRegSave, offset szRegValue
      INVOKE     lstrcat, offset szRegSave, offset szRegIcon
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, offset szRegSave, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, offset lpdwDisp

      INVOKE     lstrcpy, offset szRegSave, offset szRegPath
      INVOKE     lstrcat, offset szRegSave, offset szZero

      INVOKE     GetDlgItemText, hdlg, 805, addr szIconPath, sizeof szIconPath
      INVOKE     lstrcpy, offset szIconTemp, offset szIconPath
      INVOKE     lstrcat, offset szIconTemp, offset szComma
      INVOKE     lstrcat, offset szIconTemp, offset szNum
      INVOKE     lstrlen, offset szIconTemp
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, offset szIconTemp, eax
      INVOKE     RegCloseKey, hReg

;----------------[Set the \shell\open\command, E:\xxxx\xxxx.exe %1]-------------
      INVOKE     lstrcat, offset szRegValue, offset szRegSOC
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, offset szRegValue, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, offset lpdwDisp

      INVOKE     GetDlgItemText, hdlg, 801, addr szBuff, sizeof szBuff
;INVOKE     MessageBox,NULL, addr szBuff, offset szFileMan, MB_OK
      INVOKE     lstrlen, offset szBuff
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, offset szBuff, eax
      INVOKE     RegCloseKey, hReg

ReSet:
;----------------[Update the file ond refresh the list and combo boxes]-------------
      INVOKE     SendMessage, hList, LB_RESETCONTENT, 0, 0
      INVOKE     SendMessage, hCombo, CB_RESETCONTENT, 0, 0
         mov     sw1, 8

; Get image ID num
      INVOKE     SHGetFileInfo, addr szRegPath, 0, addr sfi, sizeof SHFILEINFO, SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_ICON
        test     eax, eax
         jz      ReLoad    ; Do error routine

      INVOKE     ImageList_GetIcon, hSingleImage, 1, ILD_NORMAL
         mov     hIcon2, eax
      INVOKE     ImageList_ReplaceIcon, hListImageList, SavImageN, hIcon2
      INVOKE     DeleteObject, hIcon2

         mov     lvi.imask, LVIF_IMAGE
       MOVmd     lvi.iItem, SavItem
         mov     lvi.iSubItem, 0
       MOVmd     lvi.iImage, sfi.iIcon
         mov     ebx, SavList
      INVOKE     SendMessage, hWndList+[ebx], LVM_SETITEM, 0, addr lvi
        test     eax, eax
         jz      ReLoad    ; Do error routine
         jmp     ReLoad

CancleIt:
      INVOKE     DeleteObject, SavIcon
      INVOKE     DeleteObject, hFontC
      INVOKE     ImageList_Destroy, hSingleImage
         and     NoDelEnt, 0           ; Enables the delete and enter virtual keys
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE
DlgRet:
         RET
AssociationDlg ENDP
END
;INVOKE     MessageBox,NULL, addr szRegSave, offset szFileMan, MB_OK
